Difference between revisions of "Topological data scripting/de"

From FreeCAD Documentation
Jump to navigation Jump to search
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(194 intermediate revisions by 2 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{docnav|Mesh Scripting|Mesh to Part}}
 
  
{{TutorialInfo/de
+
{{TOCright}}
|Topic=Programming
+
 
|Level=Intermediate
+
==Einführung==
|Time=
+
 
|Author=
+
Hier erklären wir dir, wie du das [[Part_Module/de|Part Arbeitsbereich]] direkt aus dem FreeCAD Python Interpreter oder aus einem externen Skript heraus steuern kannst. Stelle sicher, dass du den Abschnitt [[Scripting/de|Skripten]] und die Seiten [[FreeCAD_Scripting_Basics/de|FreeCAD Grundlagen Skripten]] durchblätterst, wenn du weitere Informationen über die Funktionsweise von Python Skripten in FreeCAD benötigst. Wenn du neu in Python bist, ist es eine gute Idee, zuerst den Abschnitt [[Introduction_to_Python/de|Einführung in Python]] zu lesen.
|FCVersion=
+
 
|Files=
+
===Siehe auch===
}}
+
 
 +
* [[Part_scripting/de|Part Skripten]]
 +
* [[OpenCASCADE/de|OpenCASCADE]]
  
 +
==Klassendiagramm==
  
Diese Seite beschreibt verschiedene Methoden zur Erstellung und Änderung von  [[Part Module|Part shapes (Formen)]] mittels Python. Wenn noch keine Kenntnisse über Python vorhanden sind, ist es eine gute Idee zuerst die [[Introduction to Python/de|Einführung in Python]] und [[FreeCAD Scripting Basics/de|Wie Python scripting in FreeCAD funktioniert]] zu lesen.
+
Dies ist ein [http://de.wikipedia.org/wiki/Unified_Modeling_Language Unified Modeling Language (UML)] Überblick über die wesentlichen Klassen des Part Arbweitsbereichs:
 +
[[Image:Part_Classes.jpg|center|Python Klassen des Part Arbeitsbereichs]]
  
== Einleitung ==
+
[[#top|Anfang]]
Hier wird erläutert, wie man das [[Part Module/de]] direkt im FreeCAD-Python-Interpreter oder von einem beliebigen externem Skript aus benutzt. Die Grundlagen über die Programmierung der topologischen Daten sind im [[Part_Module/de#Erläuterung der Konzepte|Part Modul Erläuterung der Konzepte]] beschrieben.  Bei weiteren Fragen zur Funktionsweise von Python-Skripten in FreeCAD sollte man auch den [[Scripting]] Abschnitt und die [[FreeCAD Scripting Basics/de]] Seiten konsultieren.
 
  
=== Klassen Diagramm ===
+
===Geometrie===
Dies ist ein [http://de.wikipedia.org/wiki/Unified_Modeling_Language Unified Modeling Language (UML)] Überblick über die wesentlichen Klassen des Part Moduls:
 
[[Image:Part_Classes.jpg|center|Python Klassen des Part-Moduls]]
 
  
=== Geometrie ===
 
 
Die geometrischen Objekte sind die Bausteine aller topologischen Objekte:
 
Die geometrischen Objekte sind die Bausteine aller topologischen Objekte:
* '''Geom''' Basis-Klasse der geometrischen Objekte
+
* '''Geom''' Basisklasse der geometrischen Objekte
 
* '''Line''' Eine gerade Linie im Raum, definiert durch den Start- und Endpunkt
 
* '''Line''' Eine gerade Linie im Raum, definiert durch den Start- und Endpunkt
 
* '''Circle''' Kreis oder Kreissegment definiert durch einen Mittelpunkt und einen Start- und Endpunkt
 
* '''Circle''' Kreis oder Kreissegment definiert durch einen Mittelpunkt und einen Start- und Endpunkt
 
* '''......''' Und demnächst mehr davon
 
* '''......''' Und demnächst mehr davon
  
=== Topologie ===
+
[[#top|Anfang]]
 +
 
 +
===Topologie===
 +
 
 
The folgenden topologischen Datentypen stehen zur Verfügung:
 
The folgenden topologischen Datentypen stehen zur Verfügung:
 
* '''Compound''' Eine Gruppe von beliebigen topologischen Objekten.
 
* '''Compound''' Eine Gruppe von beliebigen topologischen Objekten.
Line 40: Line 42:
 
* '''Shape''' Ein generischer Term für all die zuvor aufgezählten Elemente.
 
* '''Shape''' Ein generischer Term für all die zuvor aufgezählten Elemente.
  
=== Quick example : Creating simple topology ===
+
[[#top|Anfang]]
 +
 
 +
==Beispiel: Einfache Topologie erstellen==
  
 
[[Image:Wire.png|Wire]]
 
[[Image:Wire.png|Wire]]
  
 +
Wir werden nun eine Topologie erstellen, indem wir sie aus einer einfacheren Geometrie konstruieren.
 +
Als Fallstudie verwenden wir ein Teil, wie im Bild zu sehen, das aus
 +
vier Knoten, zwei Kreise und zwei Linien besteht.
 +
 +
[[#top|Anfang]]
  
We will now create a topology by constructing it out of simpler geometry.
+
===Geometrie erstellen===
As a case study we use a part as seen in the picture which consists of
 
four vertexes, two circles and two lines.
 
  
==== Creating Geometry ====
+
Zuerst erstellen wir die verschiedenen geometrischen Teile dieses Drahtes. Dabei stellen wir sicher, dass die Teile, die später verbunden werden die gleichen Knoten teilen.
First we have to create the distinct geometric parts of this wire.
 
And we have to take care that the vertexes of the geometric parts
 
are at the '''same''' position. Otherwise later on we might not be
 
able to connect the geometric parts to a topology!
 
  
So we create first the points:
+
Also erstellen wir zuerst die Punkte:
  
 
{{Code|code=
 
{{Code|code=
 +
import Part
 
from FreeCAD import Base
 
from FreeCAD import Base
V1 = Base.Vector(0,10,0)
+
V1 = Base.Vector(0, 10, 0)
V2 = Base.Vector(30,10,0)
+
V2 = Base.Vector(30, 10, 0)
V3 = Base.Vector(30,-10,0)
+
V3 = Base.Vector(30, -10, 0)
V4 = Base.Vector(0,-10,0)
+
V4 = Base.Vector(0, -10, 0)
 
}}
 
}}
  
==== Arc ====
+
[[#top|Anfang]]
 +
 
 +
===Bogen===
  
 
[[Image:Circel.png|Circle]]
 
[[Image:Circel.png|Circle]]
  
  
To create an arc of circle we make a helper point and create the arc of
+
Für jeden Bogen benötigen wir einen Hilfspunkt:
circle through three points:
 
  
 
{{Code|code=
 
{{Code|code=
VC1 = Base.Vector(-10,0,0)
+
VC1 = Base.Vector(-10, 0, 0)
C1 = Part.Arc(V1,VC1,V4)
+
C1 = Part.Arc(V1, VC1, V4)
# and the second one
+
VC2 = Base.Vector(40, 0, 0)
VC2 = Base.Vector(40,0,0)
+
C2 = Part.Arc(V2, VC2, V3)
C2 = Part.Arc(V2,VC2,V3)
 
 
}}
 
}}
  
==== Line ====
+
[[#top|Anfang]]
 +
 
 +
===Linie===
  
 
[[Image:Line.png|Line]]
 
[[Image:Line.png|Line]]
  
  
The line segment can be created very simple out of the points:
+
Die Linienabschnitte können aus zwei Punkten erstellt werden:
  
 
{{Code|code=
 
{{Code|code=
L1 = Part.LineSegment(V1,V2)
+
L1 = Part.LineSegment(V1, V2)
# and the second one
+
L2 = Part.LineSegment(V3, V4)
L2 = Part.LineSegment(V3,V4)
 
 
}}
 
}}
  
''Note: in FreeCAD 0.16 Part.Line was used, for FreeCAD 0.17 Part.LineSegment has to be used''
+
[[#top|Anfang]]
 +
 
 +
===Alles zusammensetzen===
  
==== Putting it all together ====
+
Der letzte Schritt besteht darin, die geometrischen Basiselemente zusammenzusetzen und eine topologische Form zu backen:
The last step is to put the geometric base elements together
 
and bake a topological shape:
 
  
 
{{Code|code=
 
{{Code|code=
S1 = Part.Shape([C1,L1,C2,L2])
+
S1 = Part.Shape([C1, L1, C2, L2])
 
}}
 
}}
  
==== Make a prism ====
+
[[#top|Anfang]]
Now extrude the wire in a direction and make an actual 3D shape:
+
 
 +
===Ein Prisma herstellen===
 +
 
 +
Jetzt extrudiere den Draht in eine Richtung und erzeugen eine tatsächliche 3D Form:
  
 
{{Code|code=
 
{{Code|code=
 
W = Part.Wire(S1.Edges)
 
W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0,0,10))
+
P = W.extrude(Base.Vector(0, 0, 10))
 
}}
 
}}
  
==== Show it all ====
+
[[#top|Anfang]]
 +
 
 +
===Alles anzeigen===
  
 
{{Code|code=
 
{{Code|code=
Line 118: Line 128:
 
}}
 
}}
  
== Creating basic shapes ==
+
[[#top|Anfang]]
You can easily create basic topological objects with the "make...()"
+
 
methods from the Part Module:
+
==Erstellen von Grundformen==
 +
 
 +
Du kannst ganz einfach topologische Grundobjekte mit den {{incode|make...()}} Methoden aus dem Arbeitsbereich Part erstellen:
  
 
{{Code|code=
 
{{Code|code=
b = Part.makeBox(100,100,100)
+
b = Part.makeBox(100, 100, 100)
 
Part.show(b)
 
Part.show(b)
 
}}
 
}}
  
Other make...() methods available:
+
Einige verfügbare {{incode|make...()}} Methoden:
* '''makeBox(l,w,h)''': Makes a box located in p and pointing into the direction d with the dimensions (l,w,h)
+
* {{incode|makeBox(l, w, h)}} Erstellt einen Quader, der sich in p befindet und in die Richtung d mit den Abmessungen (l,w,h) zeigt.
* '''makeCircle(radius)''': Makes a circle with a given radius
+
* {{incode|makeCircle(radius)}} Erstellt einen Kreis mit einem gegebenen Radius.
* '''makeCone(radius1,radius2,height)''': Makes a cone with the given radii and height
+
* {{incode|makeCone(radius1, radius2, height)}} Erstellt einen Kegel mit den gegebenen Radien und Höhen.
* '''makeCylinder(radius,height)''': Makes a cylinder with a given radius and height.
+
* {{incode|makeCylinder(radius, height)}} Erstellt einen Zylinder mit einem gegebenen Radius und Höhe.
* '''makeLine((x1,y1,z1),(x2,y2,z2))''': Makes a line from two points
+
* {{incode|makeLine((x1, y1, z1), (x2, y2, z2))}} Erstellt eine Linie aus zwei Punkten.
* '''makePlane(length,width)''': Makes a plane with length and width
+
* {{incode|makePlane(length, width)}} Erstellt eine Ebene mit Länge und Breite.
* '''makePolygon(list)''': Makes a polygon from a list of points
+
* {{incode|makePolygon(list)}} Erstellt ein Polygon aus einer Liste von Punkten.
* '''makeSphere(radius)''': Makes a sphere with a given radius
+
* {{incode|makeSphere(radius)}} Erstellt eine Kugel mit einem bestimmten Radius.
* '''makeTorus(radius1,radius2)''': Makes a torus with the given radii
+
* {{incode|makeTorus(radius1, radius2)}} Erstellt einen Torus mit den gegebenen Radien.
See the [[Part API]] page for a complete list of available methods of the Part module.
+
Siehe die [[Part_API/de|Part API]] Seite für eine vollständige Liste der verfügbaren Methoden des Part Arbeitsbereichs.
 +
 
 +
[[#top|Anfang]]
 +
 
 +
===Module Importieren===
  
==== Importing the needed modules ====
+
Zuerst müssen wir den Part Arbeitsbereich importieren, damit wir seinen Inhalt in Python verwenden können. Wir werden auch das Basismodul aus dem FreeCAD Modul importieren:
First we need to import the Part module so we can use its contents in python.  
 
We'll also import the Base module from inside the FreeCAD module:
 
  
 
{{Code|code=
 
{{Code|code=
Line 148: Line 162:
 
}}
 
}}
  
==== Creating a Vector ====
+
[[#top|Anfang]]
[http://en.wikipedia.org/wiki/Euclidean_vector Vectors] are one of the most
+
 
important pieces of information when building shapes. They usually contain three numbers
+
===Erstellen eines Vektors===
(but not necessarily always): the x, y and z cartesian coordinates. You
+
 
create a vector like this:
+
[http://en.wikipedia.org/wiki/Euclidean_vector Vektoren] sind einer der am häufigsten verwendeten wichtigen Informationsteile beim Bau von Formen. Sie enthalten in der Regel drei Zahlen
 +
(aber nicht notwendigerweise immer): die kartesischen Koordinaten x, y und z. Du erstellst einen Vektor wie diesen:
  
 
{{Code|code=
 
{{Code|code=
myVector = Base.Vector(3,2,0)
+
myVector = Base.Vector(3, 2, 0)
 
}}
 
}}
  
We just created a vector at coordinates x=3, y=2, z=0. In the Part module,
+
Wir haben soeben einen Vektor mit den Koordinaten X = 3, Y = 2, Z = 0 erstellt. im Part Arbeitsbereich werden Vektoren überall verwendet. Part Formen verwenden auch eine andere Art von Punkt Darstellung namens Knoten, die einfach ein Behälter ist für einen Vektor. So greifst du auf den Vektor eines Knoten zu:
vectors are used everywhere. Part shapes also use another kind of point
 
representation called Vertex which is simply a container
 
for a vector. You access the vector of a vertex like this:
 
  
 
{{Code|code=
 
{{Code|code=
 
myVertex = myShape.Vertexes[0]
 
myVertex = myShape.Vertexes[0]
print myVertex.Point
+
print(myVertex.Point)
 
> Vector (3, 2, 0)
 
> Vector (3, 2, 0)
 
}}
 
}}
  
==== Creating an Edge ====
+
[[#top|Anfang]]
An edge is nothing but a line with two vertexes:
+
 
 +
===Erstellen einer Kante===
 +
 
 +
Eine Kante ist nichts anderes als eine Linie mit zwei Knoten:
  
 
{{Code|code=
 
{{Code|code=
edge = Part.makeLine((0,0,0), (10,0,0))
+
edge = Part.makeLine((0, 0, 0), (10, 0, 0))
 
edge.Vertexes
 
edge.Vertexes
 
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]
 
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]
 
}}
 
}}
  
Note: You can also create an edge by passing two vectors:
+
Hinweis: Du kannst auch eine Kante erzeugen, indem du zwei Vektoren übergibst:
  
 
{{Code|code=
 
{{Code|code=
vec1 = Base.Vector(0,0,0)
+
vec1 = Base.Vector(0, 0, 0)
vec2 = Base.Vector(10,0,0)
+
vec2 = Base.Vector(10, 0, 0)
line = Part.LineSegment(vec1,vec2)
+
line = Part.LineSegment(vec1, vec2)
 
edge = line.toShape()
 
edge = line.toShape()
 
}}
 
}}
  
You can find the length and center of an edge like this:
+
Du kannst die Länge und den Mittelpunkt einer Kante wie diese finden:
  
 
{{Code|code=
 
{{Code|code=
Line 196: Line 211:
 
}}
 
}}
  
==== Putting the shape on screen ====
+
[[#top|Anfang]]
So far we created an edge object, but it doesn't appear anywhere on the screen.  
+
 
This is because the FreeCAD 3D scene
+
===Die Form auf den Bildschirm bringen===
only displays what you tell it to display. To do that, we use this simple
+
 
method:
+
Bisher haben wir ein Kantenobjekt erstellt, das aber nirgendwo auf dem Bildschirm erscheint.  
 +
Das liegt daran, dass die FreeCAD 3D Szene nur das anzeigt, was du ihm sagst, dass er anzeigen soll. Um das zu tun, verwenden wir folgende einfache Methode:
  
 
{{Code|code=
 
{{Code|code=
Line 206: Line 222:
 
}}
 
}}
  
The show function creates an object in our FreeCAD document and assigns our "edge" shape
+
Die Anzeigefunktion erzeugt ein Objekt in unserem FreeCAD Dokument und weist unsere "Kanten"form ihm zu. Verwende dies, wenn es an der Zeit ist, deine Erstellung auf dem Bildschirm anzuzeigen.
to it. Use this whenever it is time to display your creation on screen.  
+
 
 +
[[#top|Anfang]]
  
==== Creating a Wire ====
+
===Erstellen eines Drahts===
A wire is a multi-edge line and can be created from a list of edges
+
 
or even a list of wires:
+
Ein Draht ist eine Mehrkantenlinie und kann aus einer Liste von Kanten oder sogar einer Liste von Drähten erstellt werden:
  
 
{{Code|code=
 
{{Code|code=
edge1 = Part.makeLine((0,0,0), (10,0,0))
+
edge1 = Part.makeLine((0, 0, 0), (10, 0, 0))
edge2 = Part.makeLine((10,0,0), (10,10,0))
+
edge2 = Part.makeLine((10, 0, 0), (10, 10, 0))
wire1 = Part.Wire([edge1,edge2])  
+
wire1 = Part.Wire([edge1, edge2])  
edge3 = Part.makeLine((10,10,0), (0,10,0))
+
edge3 = Part.makeLine((10, 10, 0), (0, 10, 0))
edge4 = Part.makeLine((0,10,0), (0,0,0))
+
edge4 = Part.makeLine((0, 10, 0), (0, 0, 0))
wire2 = Part.Wire([edge3,edge4])
+
wire2 = Part.Wire([edge3, edge4])
wire3 = Part.Wire([wire1,wire2])
+
wire3 = Part.Wire([wire1, wire2])
 
wire3.Edges
 
wire3.Edges
 
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
 
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Line 226: Line 243:
 
}}
 
}}
  
Part.show(wire3) will display the 4 edges that compose our wire. Other
+
{{incode|Part.show(wire3)}}  zeigt die 4 Kanten, die unseren Draht bilden. Sonstige nützliche Informationen können leicht abgerufen werden:
useful information can be easily retrieved:
 
  
 
{{Code|code=
 
{{Code|code=
Line 240: Line 256:
 
}}
 
}}
  
==== Creating a Face ====
+
[[#top|Anfang]]
Only faces created from closed wires will be valid. In this example, wire3
+
 
is a closed wire but wire2 is not a closed wire (see above)
+
===Erstellen einer Fläche===
 +
 
 +
Nur Flächen, die aus geschlossenen Drähten erstellt wurden, sind gültig. In diesem Beispiel ist Draht3 ein geschlossener Draht, aber Draht2 ist kein geschlossener Draht (siehe oben).
  
 
{{Code|code=
 
{{Code|code=
 
face = Part.Face(wire3)
 
face = Part.Face(wire3)
 
face.Area
 
face.Area
> 99.999999999999972
+
> 99.99999999999999
 
face.CenterOfMass
 
face.CenterOfMass
 
> Vector (5, 5, 0)
 
> Vector (5, 5, 0)
Line 255: Line 273:
 
> True
 
> True
 
sface = Part.Face(wire2)
 
sface = Part.Face(wire2)
face.isValid()
+
sface.isValid()
 
> False
 
> False
 
}}
 
}}
  
Only faces will have an area, not wires nor edges.
+
Nur Flächen haben eine Grundfläche, Drähte und Kanten haben keine.
 +
 
 +
[[#top|Anfang]]
 +
 
 +
===Erstellen eines Kreises===
  
==== Creating a Circle ====
+
So einfach kann ein Kreis erstellt werden:
A circle can be created as simply as this:
 
  
 
{{Code|code=
 
{{Code|code=
Line 270: Line 291:
 
}}
 
}}
  
If you want to create it at a certain position and with a certain direction:
+
Wenn Du ihn an einer bestimmten Stelle und mit einer bestimmten Richtung erzeugen möchtest:
  
 
{{Code|code=
 
{{Code|code=
ccircle = Part.makeCircle(10, Base.Vector(10,0,0), Base.Vector(1,0,0))
+
ccircle = Part.makeCircle(10, Base.Vector(10, 0, 0), Base.Vector(1, 0, 0))
 
ccircle.Curve
 
ccircle.Curve
 
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))
 
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))
 
}}
 
}}
  
ccircle will be created at distance 10 from the x origin and will be facing
+
ccircle wird im Abstand 10 vom x Ursprung erstellt und ist nach außen entlang der x Achse gerichtet. Hinweis: {{incode|makeCircle()}} akzeptiert nur {{incode|Base.Vector()}} für die Position und normale Parameter, keine Tupel. Du kannst auch einen Teil des Kreises durch Angabe
outwards along the x axis. Note: makeCircle only accepts Base.Vector() for the position
+
eines Anfangs- und eines Endwinkels erstellen:
and normal parameters, not tuples. You can also create part of the circle by giving
 
a start and an end angle:
 
  
 
{{Code|code=
 
{{Code|code=
 
from math import pi
 
from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)
+
arc1 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 180, 360)
+
arc2 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 180, 360)
 
}}
 
}}
  
Both arc1 and arc2 jointly will make a circle. Angles should be provided in
+
Winkel sollten in Grad angegeben werden. Wenn Du Bogenmaß hast, wandelst Du sie einfach mit der Formel um:
degrees; if you have radians simply convert them using the formula:
+
{{incode/de|Grad <nowiki>=</nowiki> Bogenmaß * 180/pi}} oder mit Hilfe des Python {{incode|math}} Moduls:
degrees = radians * 180/PI or using python's math module (after doing import
 
math, of course):
 
  
 
{{Code|code=
 
{{Code|code=
 +
import math
 
degrees = math.degrees(radians)
 
degrees = math.degrees(radians)
 
}}
 
}}
  
==== Creating an Arc along points ====
+
[[#top|Anfang]]
Unfortunately there is no makeArc function, but we have the Part.Arc function to
+
 
create an arc through three points. It creates an arc object
+
===Erstellen eines Bogens entlang von Punkten===
joining the start point to the end point through the middle point.  
+
 
The arc object's .toShape() function must be called to get an edge object,  
+
Leider gibt es keine {{incode|makeArc()}} Funktion, aber wir haben die {{incode|Part.Arc()}} Funktion um einen Bogen durch drei Punkte zu erzeugen. Es erzeugt ein Bogenobjekt das den Startpunktes mit dem Endpunkt durch den Mittelpunkt verbindet. Die {{incode|toShape()}} Funktion des Bogenobjekts muss aufgerufen werden, um ein Kantenobjekt zu erhalten, wie bei der Verwendung von {{incode|Part.LineSegment}} anstelle von {{incode|Part.makeLine}}.
the same as when using Part.LineSegment instead of Part.makeLine.
 
  
 
{{Code|code=
 
{{Code|code=
arc = Part.Arc(Base.Vector(0,0,0),Base.Vector(0,5,0),Base.Vector(5,5,0))
+
arc = Part.Arc(Base.Vector(0, 0, 0), Base.Vector(0, 5, 0), Base.Vector(5, 5, 0))
 
arc
 
arc
 
> <Arc object>
 
> <Arc object>
 
arc_edge = arc.toShape()
 
arc_edge = arc.toShape()
 +
Part.show(arc_edge)
 
}}
 
}}
  
Arc only accepts Base.Vector() for points but not tuples. arc_edge is what
+
{{incode|Arc()}} akzeptiert nur {{incode|Base.Vector()}} für Punkte, aber nicht für Tupel. Du kannst auch Folgendes erhalten einen Bogen unter Verwendung eines Kreisausschnitts:
we want which we can display using Part.show(arc_edge). You can also obtain
 
an arc by using a portion of a circle:
 
  
 
{{Code|code=
 
{{Code|code=
 
from math import pi
 
from math import pi
circle = Part.Circle(Base.Vector(0,0,0),Base.Vector(0,0,1),10)
+
circle = Part.Circle(Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 10)
 
arc = Part.Arc(circle,0,pi)
 
arc = Part.Arc(circle,0,pi)
 
}}
 
}}
  
Arcs are valid edges like lines, so they can be used in wires also.
+
Bögen sind gültige Kanten wie Linien, so dass sie auch in Drähten verwendet werden können.
 +
 
 +
[[#top|Anfang]]
 +
 
 +
===Erstellen eines Polygons===
  
==== Creating a polygon ====
+
Ein Polygon ist einfach ein Draht mit mehreren geraden Kanten. Die {{incode|makePolygon()}}
A polygon is simply a wire with multiple straight edges. The makePolygon  
+
Funktion nimmt eine Liste von Punkten und erstellt einen Draht durch diese Punkte:
function takes a list of points and creates a wire through those points:
 
  
 
{{Code|code=
 
{{Code|code=
lshape_wire = Part.makePolygon([Base.Vector(0,5,0),Base.Vector(0,0,0),Base.Vector(5,0,0)])
+
lshape_wire = Part.makePolygon([Base.Vector(0, 5, 0), Base.Vector(0, 0, 0), Base.Vector(5, 0, 0)])
 
}}
 
}}
  
==== Creating a Bézier curve ====
+
[[#top|Anfang]]
Bézier curves are used to model smooth curves using a series of poles (points) and optional weightsThe function below makes a Part.BezierCurve from a series of FreeCAD.Vector points.  (Note: when "getting" and "setting" a single pole or weight, indices start at 1, not 0.)
+
 
 +
===Erstellen einer Bézier Kurve===
 +
 
 +
Bézier Kurven werden verwendet, um sanfte Kurven mit einer Reihe von Polen (Punkten) und optionalen Gewichten zu modellierenDie folgende Funktion erstellt eine {{incode|Part.BezierCurve()}} aus einer Reihe von {{incode|FreeCAD.Vector()}} Punkten.  (Hinweis: Wenn du einen einzelnen Pol oder ein Gewicht "erhältst" und "einstellst", beginnen die Indizes bei 1, nicht bei 0.)
  
 
{{Code|code=
 
{{Code|code=
Line 343: Line 365:
 
}}
 
}}
  
==== Creating a Plane ====
+
[[#top|Anfang]]
A Plane is simply a flat rectangular surface. The method used to create one is '''makePlane(length,width,[start_pnt,dir_normal])'''. By default
+
 
start_pnt = Vector(0,0,0) and dir_normal = Vector(0,0,1). Using dir_normal = Vector(0,0,1)  
+
===Erstellen einer Ebene===
will create the plane facing in the positive z axis direction, while dir_normal = Vector(1,0,0) will create the
+
 
plane facing in the positive x axis direction:
+
Eine Ebene ist einfach eine flache rechteckige Fläche. Die Methode, mit der eine solche erstellt wird, ist '''makePlane(length,width,[start_pnt,dir_normal])''''. Standardmäßig
 +
start_pnt = Vektor(0,0,0,0) und dir_normal = Vektor(0,0,1). Verwendung von dir_normal = Vector(0,0,0,1)  
 +
erzeugt die Ebene, die in Richtung der positiven z Achse zeigt, während dir_normal = Vector(1,0,0,0) die Ebene erzeugt, die in Richtung der positiven x Achse zeigt:
  
 
{{Code|code=
 
{{Code|code=
plane = Part.makePlane(2,2)
+
plane = Part.makePlane(2, 2)
 
plane
 
plane
><Face object at 028AF990>
+
> <Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3,0,0), Base.Vector(0,1,0))
+
plane = Part.makePlane(2, 2, Base.Vector(3, 0, 0), Base.Vector(0, 1, 0))
 
plane.BoundBox
 
plane.BoundBox
 
> BoundBox (3, 0, 0, 5, 0, 2)
 
> BoundBox (3, 0, 0, 5, 0, 2)
 
}}
 
}}
  
BoundBox is a cuboid enclosing the plane with a diagonal starting at
+
{{incode|BoundBox}} ist ein Quader, der die Ebene mit einer Diagonale beginnend bei
(3,0,0) and ending at (5,0,2). Here the BoundBox thickness along the y axis is zero,  
+
(3,0,0,0) und endet bei (5,0,2) einschliesst. Hier ist die {{incode|BoundBox}} Dicke entlang der y Achse Null, zumal unsere Form völlig flach ist.
since our shape is totally flat.
+
 
 +
Hinweis: {{incode|makePlane()}} akzeptiert nur {{incode|Base.Vector()}} für start_pnt und dir_normal, nicht aber Tupel.
 +
 
 +
[[#top|Anfang]]
  
Note: makePlane only accepts Base.Vector() for start_pnt and dir_normal but not tuples.
+
===Erstellen einer Ellipse===
  
==== Creating an ellipse ====
+
Es gibt mehrere Möglichkeiten, eine Ellipse zu erstellen:
There are several ways to create an ellipse:
 
  
 
{{Code|code=
 
{{Code|code=
Line 371: Line 397:
 
}}
 
}}
  
Creates an ellipse with major radius 2 and minor radius 1 with the center at (0,0,0).
+
Erzeugt eine Ellipse mit Hauptradius 2 und Nebenradius 1 mit dem Mittelpunkt bei (0,0,0).
  
 
{{Code|code=
 
{{Code|code=
Line 377: Line 403:
 
}}
 
}}
  
Creates a copy of the given ellipse.
+
Erstellt eine Kopie der angegebenen Ellipse.
  
 
{{Code|code=
 
{{Code|code=
Part.Ellipse(S1,S2,Center)
+
Part.Ellipse(S1, S2, Center)
 
}}
 
}}
  
Creates an ellipse centered on the point Center, where the plane of the
+
Erzeugt eine Ellipse, die auf den Punkt Mitte zentriert ist, an dem die Ebene der Ellipse definiert ist durch Mittelpunkt, S1 und S2, ihre Hauptachse definiert ist durch Mittelpunkt und S1, sein Hauptradius ist der Abstand zwischen Mittelpunkt und S1, und sein kleiner Radius ist der Abstand zwischen S2 und der Hauptachse.
ellipse is defined by Center, S1 and S2, its major axis is defined by
 
Center and S1, its major radius is the distance between Center and S1,  
 
and its minor radius is the distance between S2 and the major axis.
 
  
 
{{Code|code=
 
{{Code|code=
Part.Ellipse(Center,MajorRadius,MinorRadius)
+
Part.Ellipse(Center, MajorRadius, MinorRadius)
 
}}
 
}}
  
Creates an ellipse with major and minor radii MajorRadius and MinorRadius,  
+
Erstellt eine Ellipse mit Haupt- und Nebenradien Hauptradius und Nebenradius,  
located in the plane defined by Center and the normal (0,0,1)
+
die sich in der durch den Mittelpunkt definierten Ebene und der Normalen (0,0,1) befinden.
  
 
{{Code|code=
 
{{Code|code=
eli = Part.Ellipse(Base.Vector(10,0,0),Base.Vector(0,5,0),Base.Vector(0,0,0))
+
eli = Part.Ellipse(Base.Vector(10, 0, 0), Base.Vector(0, 5, 0), Base.Vector(0, 0, 0))
 
Part.show(eli.toShape())
 
Part.show(eli.toShape())
 
}}
 
}}
  
In the above code we have passed S1, S2 and center. Similar to Arc,  
+
Im obigen Code haben wir S1, S2 und Mitte überschritten. Ähnlich wie {{incode|Arc}},  
Ellipse creates an ellipse object but not edge, so we need to
+
{{incode|Ellipse}} erzeugt ein Ellipsenobjekt, aber keine Kante, also müssen wir es in eine Kante mit {{incode|toShape()}} zur Anzeige konvertieren.
convert it into an edge using toShape() for display.
 
  
Note: Arc only accepts Base.Vector() for points but not tuples.
+
Hinweis: {{incode|Ellipse()}} akzeptiert nur {{incode|Base.Vector()}} für Punkte, nicht aber für Tupel.
  
 
{{Code|code=
 
{{Code|code=
eli = Part.Ellipse(Base.Vector(0,0,0),10,5)
+
eli = Part.Ellipse(Base.Vector(0, 0, 0), 10, 5)
 
Part.show(eli.toShape())
 
Part.show(eli.toShape())
 
}}
 
}}
  
for the above Ellipse constructor we have passed center, MajorRadius and MinorRadius.
+
Für den obigen Ellipsenkonstruktor haben wir Mitte, HauptRadius und NebenRadius überschritten.
 +
 
 +
[[#top|Anfang]]
 +
 
 +
===Erstellen eines Torus===
  
==== Creating a Torus ====
+
Verwende {{incode|makeTorus(radius1, radius2, [pnt, dir, Winkel1, Winkel2, Winkel])}}.
Using '''makeTorus(radius1,radius2,[pnt,dir,angle1,angle2,angle])'''.
+
Standardmäßig ist pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = 0, Winkel2 = 360 und Winkel = 360.
By default pnt=Vector(0,0,0), dir=Vector(0,0,1), angle1=0, angle2=360 and angle=360.
+
Betrachte einen Torus als kleinen Kreis, der entlang eines großen Kreises verläuft. Radius1 ist der
Consider a torus as small circle sweeping along a big circle. Radius1 is the
+
Radius des großen Kreises, Radius2 ist der Radius des kleinen Kreises, pnt ist der Mittelpunkt
radius of the big cirlce, radius2 is the radius of the small circle, pnt is the center
+
des Torus und dir ist die Normalenrichtung. winkel1 und winkel2 sind Winkel in  
of the torus and dir is the normal direction. angle1 and angle2 are angles in  
+
Grad für den kleinen Kreis; der letzte Winkelparameter besteht darin, einen Schnitt von
radians for the small circle; the last parameter angle is to make a section of
+
den Torus:
the torus:
 
  
 
{{Code|code=
 
{{Code|code=
Line 426: Line 451:
 
}}
 
}}
  
The above code will create a torus with diameter 20 (radius 10) and thickness 4
+
Der obige Code erzeugt einen Torus mit Durchmesser 20 (Radius 10) und Dicke 4
(small circle radius 2)
+
(kleiner Kreisradius 2)
  
 
{{Code|code=
 
{{Code|code=
tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)
+
tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
 
}}
 
}}
  
The above code will create a slice of the torus.
+
Der obige Code erzeugt eine Scheibe des Torus.
  
 
{{Code|code=
 
{{Code|code=
tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 360, 180)
+
tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 360, 180)
 
}}
 
}}
  
The above code will create a semi torus; only the last parameter is changed.
+
Der obige Code erzeugt einen Halbtorus; nur der letzte Parameter wird geändert.
i.e the angle and remaining angles are defaults. Giving the angle 180 will
+
d.h. die restlichen Winkel sind Standardwerte. Die Angabe des Winkels 180 bewirkt
create the torus from 0 to 180, that is, a half torus.
+
den Torus von 0 bis 180, d.h. einen halben Torus, erzeugen.
 +
 
 +
[[#top|Anfang]]
  
==== Creating a box or cuboid ====
+
===Kasten oder Quader erstellen===
Using '''makeBox(length,width,height,[pnt,dir])'''.  
+
 
By default pnt=Vector(0,0,0) and dir=Vector(0,0,1).
+
Verwendung von {{incode|makeBox(Länge, Breite, Höhe, [pnt, dir])}}.  
 +
Standardmäßig werden pnt = Vektor(0, 0, 0) und dir = Vektor(0, 0, 1) verwendet.
  
 
{{Code|code=
 
{{Code|code=
box = Part.makeBox(10,10,10)
+
box = Part.makeBox(10, 10, 10)
 
len(box.Vertexes)
 
len(box.Vertexes)
 
> 8
 
> 8
 
}}
 
}}
  
==== Creating a Sphere ====
+
[[#top|Anfang]]
Using '''makeSphere(radius,[pnt, dir, angle1,angle2,angle3])'''. By default
+
 
pnt=Vector(0,0,0), dir=Vector(0,0,1), angle1=-90, angle2=90 and angle3=360.  
+
===Erstelle eine Kugel===
angle1 and angle2 are the vertical minimum and maximum of the sphere, angle3
+
 
is the sphere diameter.
+
Mit {{incode|makeSphere(radius, [pnt, dir, winkel1, winkel2, winkel3])}}. Standardmäßig
 +
pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = -90, Winkel2 = 90 und Winkel3 = 360.  
 +
Winkel1 und Winkel2 sind das vertikale Minimum und Maximum der Kugel, Winkel3
 +
ist der Kugeldurchmesser.
  
 
{{Code|code=
 
{{Code|code=
 
sphere = Part.makeSphere(10)
 
sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10,Base.Vector(0,0,0),Base.Vector(0,0,1),-90,90,180)
+
hemisphere = Part.makeSphere(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), -90, 90, 180)
 
}}
 
}}
  
==== Creating a Cylinder ====
+
[[#top|Anfang]]
Using '''makeCylinder(radius,height,[pnt,dir,angle])'''. By default
+
 
pnt=Vector(0,0,0),dir=Vector(0,0,1) and angle=360.
+
===Erstellen eines Zylinders===
 +
 
 +
Verwende {{incode|makeCylinder(Radius, Höhe, [pnt, dir, Winkel])}}. Standardmäßig
 +
pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.
 
{{Code|code=
 
{{Code|code=
cylinder = Part.makeCylinder(5,20)
+
cylinder = Part.makeCylinder(5, 20)
partCylinder = Part.makeCylinder(5,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)
+
partCylinder = Part.makeCylinder(5, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)
 
}}
 
}}
==== Creating a Cone ====
+
[[#top|Anfang]]
Using '''makeCone(radius1,radius2,height,[pnt,dir,angle])'''. By default
+
 
pnt=Vector(0,0,0), dir=Vector(0,0,1) and angle=360.
+
===Erstellen eines Kegels===
 +
 
 +
Verwendung {{incode|makeCone(radius1, radius2, höhe, [pnt, dir, winkel])}}. Standardmäßig
 +
pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.
 
{{Code|code=
 
{{Code|code=
cone = Part.makeCone(10,0,20)
+
cone = Part.makeCone(10, 0, 20)
semicone = Part.makeCone(10,0,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)
+
semicone = Part.makeCone(10, 0, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)
 
}}
 
}}
== Modifying shapes ==
+
[[#top|Anfang]]
There are several ways to modify shapes. Some are simple transformation operations
+
 
such as moving or rotating shapes, others are more complex, such as unioning and
+
==Formen ändern==
subtracting one shape from another.
 
  
=== Transform operations ===
+
Es gibt verschiedene Möglichkeiten, Formen zu ändern. Einige sind einfache Transformationsoperationen
 +
wie sich bewegende oder rotierende Formen, andere sind komplexer, wie die Vereinigung und
 +
Subtrahieren einer Form von einer anderen.
  
==== Translating a shape ====
+
[[#top|Anfang]]
Translating is the act of moving a shape from one place to another.  
+
 
Any shape (edge, face, cube, etc...) can be translated the same way:
+
==Umwandlungsvorgänge==
 +
 
 +
===Übersetzen einer Form===
 +
 
 +
Übersetzen ist die Handlung, eine Form von einem Ort zum anderen zu bewegen. Jede Form (Kante, Fläche, Würfel, usw...) kann auf die gleiche Weise übersetzt werden:
 
{{Code|code=
 
{{Code|code=
myShape = Part.makeBox(2,2,2)
+
myShape = Part.makeBox(2, 2, 2)
myShape.translate(Base.Vector(2,0,0))
+
myShape.translate(Base.Vector(2, 0, 0))
 
}}
 
}}
This will move our shape "myShape" 2 units in the x direction.
+
Dadurch wird unsere Form "myShape" um 2 Einheiten in die X Richtung verschoben.
 +
 
 +
[[#top|Anfang]]
  
==== Rotating a shape ====
+
===Drehen einer Form===
To rotate a shape, you need to specify the rotation center, the axis,  
+
 
and the rotation angle:
+
Um eine Form zu drehen, musst du das Rotationszentrum, die Achse, angeben, und den Rotationswinkel:
 
{{Code|code=
 
{{Code|code=
myShape.rotate(Vector(0,0,0),Vector(0,0,1),180)
+
myShape.rotate(Base.Vector(0, 0, 0),Base.Vector(0, 0, 1), 180)
 
}}
 
}}
The above code will rotate the shape 180 degrees around the Z Axis.
+
Der obige Code dreht die Form um 180 Grad um die Z Achse.
  
==== Generic transformations with matrixes ====
+
[[#top|Anfang]]
A matrix is a very convenient way to store transformations in the 3D
+
 
world. In a single matrix, you can set translation, rotation and scaling
+
===Matrix Umformungen===
values to be applied to an object. For example:
+
 
 +
Eine Matrix ist eine sehr bequeme Möglichkeit, Transformationen in der 3D Welt. In einer einzigen Matrix kannst du Translation, Rotation und Skalierung einstellen Werte, die auf ein Objekt angewendet werden sollen. Zum Beispiel:
 
{{Code|code=
 
{{Code|code=
 
myMat = Base.Matrix()
 
myMat = Base.Matrix()
myMat.move(Base.Vector(2,0,0))
+
myMat.move(Base.Vector(2, 0, 0))
 
myMat.rotateZ(math.pi/2)
 
myMat.rotateZ(math.pi/2)
 
}}
 
}}
Note: FreeCAD matrixes work in radians. Also, almost all matrix operations
+
Hinweis: FreeCAD Matrizen arbeiten im Bogenmaß. Außerdem werden fast alle Matrix Operationen die einen Vektor nehmen, können auch drei Zahlen nehmen, so dass diese beiden Linien dasselbe tun:
that take a vector can also take three numbers, so these two lines do the same thing:
 
 
{{Code|code=
 
{{Code|code=
myMat.move(2,0,0)
+
myMat.move(2, 0, 0)
myMat.move(Base.Vector(2,0,0))
+
myMat.move(Base.Vector(2, 0, 0))
 
}}
 
}}
Once our matrix is set, we can apply it to our shape. FreeCAD provides two
+
Wenn unsere Matrix einmal festgelegt ist, können wir sie auf unsere Form anwenden. FreeCAD bietet zwei
methods for doing that: transformShape() and transformGeometry(). The difference
+
Methoden, um das zu tun: {{incode|transformShape()}} und {{incode|transformGeometry()}}. Der Unterschied
is that with the first one, you are sure that no deformations will occur (see
+
ist, dass Sie bei der ersten sicher sind, dass keine Verformungen auftreten werden (siehe [[#Scaling a shape/de|Skalierung einer Form]] unten). Wir können unsere Transformation wie folgt anwenden:
"scaling a shape" below). We can apply our transformation like this:
 
 
{{Code|code=
 
{{Code|code=
myShape.trasformShape(myMat)
+
myShape.transformShape(myMat)
 
}}
 
}}
or
+
oder
 
{{Code|code=
 
{{Code|code=
 
myShape.transformGeometry(myMat)
 
myShape.transformGeometry(myMat)
 
}}
 
}}
==== Scaling a shape ====
+
[[#top|Anfang]]
Scaling a shape is a more dangerous operation because, unlike translation
+
 
or rotation, scaling non-uniformly (with different values for x, y and z)  
+
===Skalieren einer Form===
can modify the structure of the shape. For example, scaling a circle with
+
 
a higher value horizontally than vertically will transform it into an
+
Das Skalieren einer Form ist eine gefährlichere Operation, denn im Gegensatz zur Übersetzung
ellipse, which behaves mathematically very differently. For scaling, we
+
oder Rotation, ungleichmäßige Skalierung (mit unterschiedlichen Werten für X, Y und Z)  
can't use the transformShape, we must use transformGeometry():
+
kann die Struktur der Form verändern. Beispielsweise kann die Skalierung eines Kreises mit
 +
ein höherer Wert horizontal als vertikal wandelt ihn in einen
 +
Ellipse, die sich mathematisch sehr unterschiedlich verhält. Für die Skalierung haben wir
 +
nicht die {{incode|transformShape()}} verwenden können, müssen wir {{incode|transformGeometry()}} verwenden:
 
{{Code|code=
 
{{Code|code=
 
myMat = Base.Matrix()
 
myMat = Base.Matrix()
myMat.scale(2,1,1)
+
myMat.scale(2, 1, 1)
 
myShape=myShape.transformGeometry(myMat)
 
myShape=myShape.transformGeometry(myMat)
 
}}
 
}}
=== Boolean Operations ===
+
[[#top|Anfang]]
 +
 
 +
==Boolesche Operationen==
 +
 
 +
===Subtraktion===
  
==== Subtraction ====
+
Das Subtrahieren einer Form von einer anderen Form wird in FreeCAD "Schnitt" genannt und wird so gemacht:
Subtracting a shape from another one is called "cut" in OCC/FreeCAD jargon
 
and is done like this:
 
 
{{Code|code=
 
{{Code|code=
cylinder = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
+
cylinder = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
sphere = Part.makeSphere(5,Base.Vector(5,0,0))
+
sphere = Part.makeSphere(5, Base.Vector(5, 0, 0))
 
diff = cylinder.cut(sphere)
 
diff = cylinder.cut(sphere)
 
}}
 
}}
==== Intersection ====
+
[[#top|Anfang]]
The same way, the intersection between two shapes is called "common" and is done
+
 
this way:
+
===Überschneidung===
 +
 
 +
Auf die gleiche Weise wird die Überschneidung zwischen zwei Formen als "gemeinsam" bezeichnet und
 +
auf diese Weise gemacht:
 
{{Code|code=
 
{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
+
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
+
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
 
common = cylinder1.common(cylinder2)
 
common = cylinder1.common(cylinder2)
 
}}
 
}}
==== Union ====
+
[[#top|Anfang]]
Union is called "fuse" and works the same way:
+
 
 +
===Vereinigen===
 +
 
 +
Vereinigen wird "Verschmelzen" genannt und funktioniert auf dieselbe Weise:
 
{{Code|code=
 
{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
+
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
+
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
 
fuse = cylinder1.fuse(cylinder2)
 
fuse = cylinder1.fuse(cylinder2)
 
}}
 
}}
==== Section ====
+
[[#top|Anfang]]
A Section is the intersection between a solid shape and a plane shape.
+
 
It will return an intersection curve, a compound curve composed of edges.
+
===Abschnitt===
 +
 
 +
Ein "Abschnitt" ist der Kreuzungspunkt zwischen einer festen Form und einer ebenen Form.
 +
Er gibt eine Kreuzungskurve, eine Verbundkurve, die aus Kanten besteht zurück.
 
{{Code|code=
 
{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
+
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
+
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
 
section = cylinder1.section(cylinder2)
 
section = cylinder1.section(cylinder2)
 
section.Wires
 
section.Wires
Line 579: Line 636:
 
  <Edge object at 0D8F4BB0>]
 
  <Edge object at 0D8F4BB0>]
 
}}
 
}}
==== Extrusion ====
+
[[#top|Anfang]]
Extrusion is the act of "pushing" a flat shape in a certain direction, resulting in
+
 
a solid body. Think of a circle becoming a tube by "pushing it out":  
+
===Extrusion===
 +
 
 +
Extrusion ist der Vorgang des "Drückens" einer flachen Form in eine bestimmte Richtung, was zu
 +
einem festen Körper führt. Stell dir vor, dass ein Kreis durch "Herausschieben" zu einer Röhre wird:  
 
{{Code|code=
 
{{Code|code=
 
circle = Part.makeCircle(10)
 
circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0,0,2))
+
tube = circle.extrude(Base.Vector(0, 0, 2))
 
}}
 
}}
If your circle is hollow, you will obtain a hollow tube. If your circle is actually
+
Wenn dein Kreis hohl ist, erhälst du ein hohles Rohr. Wenn dein Kreis tatsächlich eine Scheibe mit einer gefüllten Fläche ist, erhälst du einen massiven Zylinder:
a disc with a filled face, you will obtain a solid cylinder:
 
 
{{Code|code=
 
{{Code|code=
 
wire = Part.Wire(circle)
 
wire = Part.Wire(circle)
 
disc = Part.Face(wire)
 
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0,0,2))
+
cylinder = disc.extrude(Base.Vector(0, 0, 2))
 
}}
 
}}
== Exploring shapes ==
+
[[#top|Anfang]]
You can easily explore the topological data structure:
+
 
 +
==Formen untersuchen==
 +
 
 +
Du kannst die topologische Datenstruktur leicht erkunden:
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
b = Part.makeBox(100,100,100)
+
b = Part.makeBox(100, 100, 100)
 
b.Wires
 
b.Wires
 
w = b.Wires[0]
 
w = b.Wires[0]
Line 610: Line 672:
 
v.Point
 
v.Point
 
}}
 
}}
By typing the lines above in the python interpreter, you will gain a good
+
Durch tippen der obigen Zeilen in den Python Interpreter, erhälst du eine gutes Verständnis der Struktur von Teilobjekten. Hier hat unser {{incode|makeBox()}} Befehl eine feste Form geschaffen. Dieser Volumenkörper enthält, wie alle Teil Volumenkörper, Flächen. Flächen enthalten immer Drähte, d.h. Listen von Kanten, die die Fläche begrenzen. Jede Fläche hat mindestens einen geschlossenen Draht (sie kann mehr haben, wenn die Fläche ein Loch hat). In dem Draht können wir jede Kante einzeln betrachten, und innerhalb jeder Kante können wir siehe die Eckpunkte. Gerade Kanten haben offensichtlich nur zwei Knoten.  
understanding of the structure of Part objects. Here, our makeBox() command
+
 
created a solid shape. This solid, like all Part solids, contains faces.  
+
[[#top|Anfang]]
Faces always contain wires, which are lists of edges that border the face.  
+
 
Each face has at least one closed wire (it can have more if the face has a hole).  
+
===Kantenanalyse===
In the wire, we can look at each edge separately, and inside each edge, we can
 
see the vertexes. Straight edges have only two vertexes, obviously.  
 
  
=== Edge analysis ===
+
Im Falle einer Kante, die eine willkürliche Kurve ist, ist es am wahrscheinlichsten, dass du
In case of an edge, which is an arbitrary curve, it's most likely you want to
+
eine Diskretisierung durchführen möchtest. In FreeCAD werden die Kanten durch ihre Länge parametrisiert.  
do a discretization. In FreeCAD the edges are parametrized by their lengths.  
+
Das bedeutet, dass du eine Kante/Kurve anhand ihrer Länge entlang laufen kannst:
That means you can walk an edge/curve by its length:
 
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
box = Part.makeBox(100,100,100)
+
box = Part.makeBox(100, 100, 100)
 
anEdge = box.Edges[0]
 
anEdge = box.Edges[0]
print anEdge.Length
+
print(anEdge.Length)
 
}}
 
}}
Now you can access a lot of properties of the edge by using the length as a
+
Jetzt kannst du auf viele Eigenschaften der Kante zugreifen, indem du die Länge als
position. That means if the edge is 100mm long the start position is 0 and
+
Position verwendest. Das heißt, wenn die Kante 100 mm lang ist, ist die Startposition 0 und
the end position 100.  
+
die Endposition 100.  
 
{{Code|code=
 
{{Code|code=
anEdge.tangentAt(0.0)     # tangent direction at the beginning
+
anEdge.tangentAt(0.0)         # tangent direction at the beginning
anEdge.valueAt(0.0)       # Point at the beginning
+
anEdge.valueAt(0.0)           # Point at the beginning
anEdge.valueAt(100.0)     # Point at the end of the edge
+
anEdge.valueAt(100.0)         # Point at the end of the edge
anEdge.derivative1At(50.0) # first derivative of the curve in the middle
+
anEdge.derivative1At(50.0)     # first derivative of the curve in the middle
anEdge.derivative2At(50.0) # second derivative of the curve in the middle
+
anEdge.derivative2At(50.0)     # second derivative of the curve in the middle
anEdge.derivative3At(50.0) # third derivative of the curve in the middle
+
anEdge.derivative3At(50.0)     # third derivative of the curve in the middle
 
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
 
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0)   # the curvature
+
anEdge.curvatureAt(50.0)       # the curvature
anEdge.normalAt(50)       # normal vector at that position (if defined)
+
anEdge.normalAt(50)           # normal vector at that position (if defined)
 
}}
 
}}
=== Using the selection ===
+
[[#top|Anfang]]
Here we see now how we can use the selection the user did in the viewer.
+
 
First of all we create a box and show it in the viewer.
+
===Verwendung einer Auswahl===
 +
 
 +
Hier sehen wir nun, wie wir eine Auswahl verwenden können, die der Benutzer im Betrachter getroffen hat.
 +
Zuerst erstellen wir einen Kasten und zeigen ihn im Betrachter an.
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Part.show(Part.makeBox(100,100,100))
+
Part.show(Part.makeBox(100, 100, 100))
 
Gui.SendMsgToActiveView("ViewFit")
 
Gui.SendMsgToActiveView("ViewFit")
 
}}
 
}}
Now select some faces or edges. With this script you can
+
Wähle nun einige Flächen oder Kanten aus. Mit diesem Skript kannst du über alle ausgewählten Objekte und deren Unterelemente iterieren:
iterate over all selected objects and their sub elements:
 
 
{{Code|code=
 
{{Code|code=
 
for o in Gui.Selection.getSelectionEx():
 
for o in Gui.Selection.getSelectionEx():
print o.ObjectName
+
    print(o.ObjectName)
for s in o.SubElementNames:
+
    for s in o.SubElementNames:
print "name: ",s
+
        print("name: ", s)
for s in o.SubObjects:
+
        for s in o.SubObjects:
print "object: ",s
+
            print("object: ", s)
 
}}
 
}}
Select some edges and this script will calculate the length:
+
Wähle einige Kanten aus und dieses Skript berechnet die Länge:
 
{{Code|code=
 
{{Code|code=
 
length = 0.0
 
length = 0.0
 
for o in Gui.Selection.getSelectionEx():
 
for o in Gui.Selection.getSelectionEx():
for s in o.SubObjects:
+
    for s in o.SubObjects:
length += s.Length
+
        length += s.Length
print "Length of the selected edges:" ,length
+
 
 +
print("Length of the selected edges: ", length)
 
}}
 
}}
== Complete example: The OCC bottle ==
+
[[#top|Anfang]]
A typical example found in the
+
 
[http://www.opencascade.com/doc/occt-6.9.0/overview/html/occt__tutorial.html#sec1 OpenCasCade Technology Tutorial]  
+
==Beispiel: Die OCC Flasche==
is how to build a bottle. This is a good exercise for FreeCAD too. In fact,  
+
 
if you follow our example below and the OCC page simultaneously, you will
+
Ein typisches Beispiel, das auf der [https://www.opencascade.com/doc/occt-6.9.0/overview/html/occt__tutorial.html OpenCasCade Technology Website] zu finden ist, ist der Bau einer Flasche. Dies ist auch eine gute Übung für FreeCAD. Wenn du unserem Beispiel unten und der OCC-Seite gleichzeitig folgst, wirst du sehen, wie gut OCC Strukturen in FreeCAD implementiert sind. Das Skript ist in der FreeCAD Installation enthalten (innerhalb des Ordners {{FileName|Mod/Part}}) und kann vom Python Interpreter durch Eintippen aufgerufen werden:
see how well OCC structures are implemented in FreeCAD. The complete script
 
below is also included in the FreeCAD installation (inside the Mod/Part folder) and
 
can be called from the python interpreter by typing:
 
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Line 682: Line 741:
 
Part.show(bottle)
 
Part.show(bottle)
 
}}
 
}}
=== The complete script ===
+
[[#top|Anfang]]
Here is the complete MakeBottle script:
+
 
 +
===Das Skript====
 +
 
 +
Für die Zwecke dieses Tutoriums werden wir eine reduzierte Version des Skripts in Betracht ziehen. In dieser Version wird die Flasche nicht ausgehöhlt, und der Flaschenhals wird nicht mit einem Gewinde versehen.
 
{{Code|code=
 
{{Code|code=
import Part, FreeCAD, math
+
import Part, math
 
from FreeCAD import Base
 
from FreeCAD import Base
  
def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
+
def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
  aPnt1=Base.Vector(-myWidth/2.,0,0)
+
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
  aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
+
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
  aPnt3=Base.Vector(0,-myThickness/2.,0)
+
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
  aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
+
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
  aPnt5=Base.Vector(myWidth/2.,0,0)
+
    aPnt5=Base.Vector(myWidth / 2., 0, 0)
 
+
 
  aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
+
    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
  aSegment1=Part.LineSegment(aPnt1,aPnt2)
+
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
  aSegment2=Part.LineSegment(aPnt4,aPnt5)
+
    aSegment2=Part.LineSegment(aPnt4, aPnt5)
  aEdge1=aSegment1.toShape()
+
 
  aEdge2=aArcOfCircle.toShape()
+
    aEdge1=aSegment1.toShape()
  aEdge3=aSegment2.toShape()
+
    aEdge2=aArcOfCircle.toShape()
  aWire=Part.Wire([aEdge1,aEdge2,aEdge3])
+
    aEdge3=aSegment2.toShape()
 
+
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])
  aTrsf=Base.Matrix()
+
 
  aTrsf.rotateZ(math.pi) # rotate around the z-axis
+
    aTrsf=Base.Matrix()
 
+
    aTrsf.rotateZ(math.pi) # rotate around the z-axis
  aMirroredWire=aWire.transformGeometry(aTrsf)
+
 
  myWireProfile=Part.Wire([aWire,aMirroredWire])
+
    aMirroredWire=aWire.copy()
  myFaceProfile=Part.Face(myWireProfile)
+
    aMirroredWire.transformShape(aTrsf)
  aPrismVec=Base.Vector(0,0,myHeight)
+
    myWireProfile=Part.Wire([aWire, aMirroredWire])
  myBody=myFaceProfile.extrude(aPrismVec)
+
 
  myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)
+
    myFaceProfile=Part.Face(myWireProfile)
  neckLocation=Base.Vector(0,0,myHeight)
+
    aPrismVec=Base.Vector(0, 0, myHeight)
  neckNormal=Base.Vector(0,0,1)
+
    myBody=myFaceProfile.extrude(aPrismVec)
  myNeckRadius = myThickness / 4.
+
 
  myNeckHeight = myHeight / 10
+
    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)
  myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)
+
 
  myBody = myBody.fuse(myNeck)
+
    neckLocation=Base.Vector(0, 0, myHeight)
 
+
    neckNormal=Base.Vector(0, 0, 1)
  faceToRemove = 0
+
 
  zMax = -1.0
+
    myNeckRadius = myThickness / 4.
 
+
    myNeckHeight = myHeight / 10.
  for xp in myBody.Faces:
+
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)
      try:
+
    myBody = myBody.fuse(myNeck)
          surf = xp.Surface
+
 
          if type(surf) == Part.Plane:
+
    return myBody
              z = surf.Position.z
 
              if z > zMax:
 
                  zMax = z
 
                  faceToRemove = xp
 
      except:
 
          continue
 
 
 
  myBody = myBody.makeFillet(myThickness/12.0,myBody.Edges)
 
 
 
  return myBody
 
  
el = makeBottle()
+
el = makeBottleTut()
 
Part.show(el)
 
Part.show(el)
 
}}
 
}}
=== Detailed explanation ===
+
[[#top|Anfang]]
 +
 
 +
===Detaillierte Erklärung===
 
{{Code|code=
 
{{Code|code=
import Part, FreeCAD, math
+
import Part, math
 
from FreeCAD import Base
 
from FreeCAD import Base
 
}}
 
}}
We will need, of course, the Part module, but also the FreeCAD.Base module,  
+
Wir benötigen natürlich das Modul {{incode|Part}}, aber auch das Modul {{incode|FreeCAD.Base}}, das grundlegende FreeCAD Strukturen wie Vektoren und Matrizen enthält.
which contains basic FreeCAD structures like vectors and matrixes.
+
 
 
{{Code|code=
 
{{Code|code=
def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
+
def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
  aPnt1=Base.Vector(-myWidth/2.,0,0)
+
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
  aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
+
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
  aPnt3=Base.Vector(0,-myThickness/2.,0)
+
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
  aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
+
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
  aPnt5=Base.Vector(myWidth/2.,0,0)
+
    aPnt5=Base.Vector(myWidth / 2., 0, 0)
 
}}
 
}}
Here we define our makeBottle function. This function can be called without
+
 
arguments, like we did above, in which case default values for width, height,  
+
Hier definieren wir unsere {{incode|makeBottleTut}} Funktion. Diese Funktion kann aufgerufen werden ohne
and thickness will be used. Then, we define a couple of points that will be used
+
Argumente, wie wir es oben getan haben, in diesem Fall Standardwerte für Breite und Höhe, und Dicke verwendet werden. Dann definieren wir ein paar Punkte, die verwendet werden für den Aufbau unseres Basisprofils.
for building our base profile.
+
 
 
{{Code|code=
 
{{Code|code=
  aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
+
    ...
  aSegment1=Part.LineSegment(aPnt1,aPnt2)
+
    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
  aSegment2=Part.LineSegment(aPnt4,aPnt5)
+
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
 +
    aSegment2=Part.LineSegment(aPnt4, aPnt5)
 
}}
 
}}
Here we actually define the geometry: an arc, made of three points, and two
+
 
line segments, made of two points.
+
Hier definieren wir die Geometrie: einen Bogen, der aus drei Punkten besteht, und zwei Liniensegmente, die aus zwei Punkten bestehen.
 +
 
 
{{Code|code=
 
{{Code|code=
  aEdge1=aSegment1.toShape()
+
    ...
  aEdge2=aArcOfCircle.toShape()
+
    aEdge1=aSegment1.toShape()
  aEdge3=aSegment2.toShape()
+
    aEdge2=aArcOfCircle.toShape()
  aWire=Part.Wire([aEdge1,aEdge2,aEdge3])
+
    aEdge3=aSegment2.toShape()
 +
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])
 
}}
 
}}
Remember the difference between geometry and shapes? Here we build
+
 
shapes out of our construction geometry. Three edges (edges can be straight
+
Erinnerst du dich an den Unterschied zwischen Geometrie und Formen? Hier bauen wir Formen aus unserer Konstruktionsgeometrie. Drei Kanten (Kanten können gerade sein oder gebogen), dann einen Draht hergestellt aus diesen drei Kanten.
or curved), then a wire made of those three edges.
+
 
 
{{Code|code=
 
{{Code|code=
  aTrsf=Base.Matrix()
+
    ...
  aTrsf.rotateZ(math.pi) # rotate around the z-axis
+
    aTrsf=Base.Matrix()
  aMirroredWire=aWire.transformGeometry(aTrsf)
+
    aTrsf.rotateZ(math.pi) # rotate around the z-axis
  myWireProfile=Part.Wire([aWire,aMirroredWire])
+
 
 +
    aMirroredWire=aWire.copy()
 +
    aMirroredWire.transformShape(aTrsf)
 +
    myWireProfile=Part.Wire([aWire, aMirroredWire])
 
}}
 
}}
So far we have built only a half profile. Instead of building the whole profile
+
 
the same way, we can just mirror what we did and glue both halves together.  
+
Bislang haben wir nur ein halbes Profil erstellt. Anstatt das ganze Profil zu bauen
We first create a matrix. A matrix is a very common way to apply transformations
+
Auf die gleiche Weise können wir einfach spiegeln, was wir getan haben, und beide Hälften zusammenkleben. Zuerst erstellen wir eine Matrix. Eine Matrix ist ein sehr gebräuchlicher Weg, um Transformationen auf Objekte in der 3D Welt anzuwenden, da sie in einer Struktur alle grundlegenden
to objects in the 3D world, since it can contain in one structure all basic
+
Transformationen, denen 3D Objekte unterzogen werden können (Verschieben, Drehen und Skalieren) enthalten.   
transformations that 3D objects can undergo (move, rotate and scale).   
+
Nachdem wir die Matrix erstellt haben, spiegeln wir sie, dann erstellen wir eine Kopie unseres Drahtes
After we create the matrix we mirror it, then we create a copy of our wire
+
und wenden die Transformationsmatrix darauf an. Wir haben jetzt zwei Drähte, und
with that transformation matrix applied to it. We now have two wires, and
+
können wir einen dritten Draht aus ihnen machen, da Drähte eigentlich Listen von Kanten sind.
we can make a third wire out of them, since wires are actually lists of edges.
+
 
 
{{Code|code=
 
{{Code|code=
  myFaceProfile=Part.Face(myWireProfile)
+
    ...
  aPrismVec=Base.Vector(0,0,myHeight)
+
    myFaceProfile=Part.Face(myWireProfile)
  myBody=myFaceProfile.extrude(aPrismVec)
+
    aPrismVec=Base.Vector(0, 0, myHeight)
  myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)
+
    myBody=myFaceProfile.extrude(aPrismVec)
 +
 
 +
    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)
 
}}
 
}}
Now that we have a closed wire, it can be turned into a face. Once we have a face,  
+
 
we can extrude it. In doing so, we make a solid. Then we apply a nice little
+
Nun, da wir einen geschlossenen Draht haben, kann er in eine Fläche verwandelt werden. Sobald wir eine Fläche haben, können wir es extrudieren. Auf diese Weise machen wir einen Festkörper. Dann wenden wir eine schöne kleine Verrundung auf unser Objekt an, weil wir uns um gutes Design kümmern, nicht wahr?
fillet to our object because we care about good design, don't we?
 
 
{{Code|code=
 
{{Code|code=
  neckLocation=Base.Vector(0,0,myHeight)
+
    ...
  neckNormal=Base.Vector(0,0,1)
+
    neckLocation=Base.Vector(0, 0, myHeight)
  myNeckRadius = myThickness / 4.
+
    neckNormal=Base.Vector(0, 0, 1)
  myNeckHeight = myHeight / 10
+
 
  myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)
+
    myNeckRadius = myThickness / 4.
 +
    myNeckHeight = myHeight / 10.
 +
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)
 
}}
 
}}
At this point, the body of our bottle is made, but we still need to create a neck. So we
+
An diesem Punkt ist der Körper unserer Flasche hergestellt, aber wir müssen noch einen Hals schaffen. Wir stellen einen neuen Körper mit einem Zylinder her.
make a new solid, with a cylinder.
 
 
{{Code|code=
 
{{Code|code=
  myBody = myBody.fuse(myNeck)
+
    ...
 +
    myBody = myBody.fuse(myNeck)
 
}}
 
}}
The fuse operation, which in other applications is sometimes called a union, is very
+
Der Verschmelzungsoperation ist sehr leistungsstark. Sie kümmert sich um das Kleben, was geklebt werden muss, und entfernt Teile, die entfernt werden müssen.
powerful. It will take care of gluing what needs to be glued and remove parts that
 
need to be removed.
 
 
{{Code|code=
 
{{Code|code=
  return myBody
+
    ...
 +
    return myBody
 
}}
 
}}
Then, we return our Part solid as the result of our function.  
+
Dann geben wir als Ergebnis unserer Funktion unseren Part Volumenkörper zurück.  
 
{{Code|code=
 
{{Code|code=
el = makeBottle()
+
el = makeBottleTut()
 
Part.show(el)
 
Part.show(el)
 
}}
 
}}
Finally, we call the function to actually create the part, then make it visible.
+
Schließlich rufen wir die Funktion auf, um das Teil tatsächlich zu erstellen und es dann sichtbar zu machen.
 +
 
 +
[[#top|Anfang]]
  
==Box pierced==
+
==Beispiel: Durchbohrter Quader==
Here is a complete example of building a pierced box.
 
  
The construction is done one side at a time; when the cube is finished, it is hollowed out by cutting a cylinder through it.
+
Hier ist ein vollständiges Beispiel für den Bau eines durchbohrten Quaders.
 +
 
 +
Der Aufbau erfolgt von einer Seite nach der anderen. Wenn der Würfel fertig ist, wird er durch das Durchschneiden eines Zylinders ausgehöhlt.
 
{{Code|code=
 
{{Code|code=
import Draft, Part, FreeCAD, math, PartGui, FreeCADGui, PyQt4
+
import Part, math
from math import sqrt, pi, sin, cos, asin
 
 
from FreeCAD import Base
 
from FreeCAD import Base
  
 
size = 10
 
size = 10
poly = Part.makePolygon( [ (0,0,0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])
+
poly = Part.makePolygon([(0, 0, 0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])
  
 
face1 = Part.Face(poly)
 
face1 = Part.Face(poly)
Line 842: Line 906:
 
face6 = Part.Face(poly)
 
face6 = Part.Face(poly)
 
      
 
      
myMat = FreeCAD.Matrix()
+
myMat = Base.Matrix()
myMat.rotateZ(math.pi/2)
+
 
 +
myMat.rotateZ(math.pi / 2)
 
face2.transformShape(myMat)
 
face2.transformShape(myMat)
face2.translate(FreeCAD.Vector(size, 0, 0))
+
face2.translate(Base.Vector(size, 0, 0))
  
myMat.rotateZ(math.pi/2)
+
myMat.rotateZ(math.pi / 2)
 
face3.transformShape(myMat)
 
face3.transformShape(myMat)
face3.translate(FreeCAD.Vector(size, size, 0))
+
face3.translate(Base.Vector(size, size, 0))
  
myMat.rotateZ(math.pi/2)
+
myMat.rotateZ(math.pi / 2)
 
face4.transformShape(myMat)
 
face4.transformShape(myMat)
face4.translate(FreeCAD.Vector(0, size, 0))
+
face4.translate(Base.Vector(0, size, 0))
 +
 
 +
myMat = Base.Matrix()
  
myMat = FreeCAD.Matrix()
+
myMat.rotateX(-math.pi / 2)
myMat.rotateX(-math.pi/2)
 
 
face5.transformShape(myMat)
 
face5.transformShape(myMat)
  
 
face6.transformShape(myMat)               
 
face6.transformShape(myMat)               
face6.translate(FreeCAD.Vector(0,0,size))
+
face6.translate(Base.Vector(0, 0, size))
 
 
myShell = Part.makeShell([face1,face2,face3,face4,face5,face6]) 
 
  
 +
myShell = Part.makeShell([face1, face2, face3, face4, face5, face6]) 
 
mySolid = Part.makeSolid(myShell)
 
mySolid = Part.makeSolid(myShell)
mySolidRev = mySolid.copy()
 
mySolidRev.reverse()
 
  
myCyl = Part.makeCylinder(2,20)
+
myCyl = Part.makeCylinder(2, 20)
myCyl.translate(FreeCAD.Vector(size/2, size/2, 0))
+
myCyl.translate(Base.Vector(size / 2, size / 2, 0))
  
cut_part = mySolidRev.cut(myCyl)
+
cut_part = mySolid.cut(myCyl)
  
 
Part.show(cut_part)
 
Part.show(cut_part)
 
}}
 
}}
== Loading and Saving ==
+
[[#top|Anfang]]
There are several ways to save your work in the Part module. You can
 
of course save your FreeCAD document, but you can also save Part
 
objects directly to common CAD formats, such as BREP, IGS, STEP and STL.
 
  
Saving a shape to a file is easy. There are exportBrep(), exportIges(),  
+
==Laden und Speichern==
exportStl() and exportStep() methods available for all shape objects.  
+
 
So, doing:
+
Es gibt mehrere Möglichkeiten, deine Arbeit zu speichern. Du kannst natürlich dein FreeCAD Dokument speichern, aber Du kannst auch [[Part_workbench/de|Part]] Objekte direkt in gängigen CAD Formaten wie BREP, IGS, STEP und STL speichern.
 +
 
 +
Das Speichern einer Form in einer Datei ist einfach. Es stehen die Methoden {{incode|exportBrep()}}, {{incode|exportIges()}}, {{incode|exportStep()}} und {{incode|exportStl()}} für alle Formobjekte zur Verfügung.  
 +
Also, ausführen:
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
s = Part.makeBox(0,0,0,10,10,10)
+
s = Part.makeBox(10, 10, 10)
 
s.exportStep("test.stp")
 
s.exportStep("test.stp")
 
}}
 
}}
will save our box into a STEP file. To load a BREP,  
+
wird unseren Quader in eine STEP Datei gespeichert. Um eine BREP , IGES oder STEP Datei zu laden:
IGES or STEP file:
 
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Line 895: Line 957:
 
s.read("test.stp")
 
s.read("test.stp")
 
}}
 
}}
To convert an '''.stp''' file to an '''.igs''' file:
+
Um eine STEP Datei in eine IGS Datei umzuwandeln:
 
{{Code|code=
 
{{Code|code=
 
  import Part
 
  import Part
Line 902: Line 964:
 
  s.exportIges("file.igs") # outbound file igs
 
  s.exportIges("file.igs") # outbound file igs
 
}}
 
}}
Note that importing or opening BREP, IGES or STEP files can also be done
+
[[#top|Anfang]]
directly from the File → Open or File → Import menu, while exporting
 
can be done with File → Export.
 
 
 
{{docnav|Mesh Scripting|Mesh to Part}}
 
 
 
{{Userdocnavi}}
 
 
 
<div class="mw-translate-fuzzy">
 
[[Category:Poweruser Documentation/de]] [[Category:Python Code/de]]
 
</div>
 
 
 
[[Category:Python Code]]
 
 
 
  
 +
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 
{{clear}}
 
{{clear}}

Latest revision as of 17:08, 11 October 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文 • ‎中文(中国大陆)‎

Einführung

Hier erklären wir dir, wie du das Part Arbeitsbereich direkt aus dem FreeCAD Python Interpreter oder aus einem externen Skript heraus steuern kannst. Stelle sicher, dass du den Abschnitt Skripten und die Seiten FreeCAD Grundlagen Skripten durchblätterst, wenn du weitere Informationen über die Funktionsweise von Python Skripten in FreeCAD benötigst. Wenn du neu in Python bist, ist es eine gute Idee, zuerst den Abschnitt Einführung in Python zu lesen.

Siehe auch

Klassendiagramm

Dies ist ein Unified Modeling Language (UML) Überblick über die wesentlichen Klassen des Part Arbweitsbereichs:

Python Klassen des Part Arbeitsbereichs

Anfang

Geometrie

Die geometrischen Objekte sind die Bausteine aller topologischen Objekte:

  • Geom Basisklasse der geometrischen Objekte
  • Line Eine gerade Linie im Raum, definiert durch den Start- und Endpunkt
  • Circle Kreis oder Kreissegment definiert durch einen Mittelpunkt und einen Start- und Endpunkt
  • ...... Und demnächst mehr davon

Anfang

Topologie

The folgenden topologischen Datentypen stehen zur Verfügung:

  • Compound Eine Gruppe von beliebigen topologischen Objekten.
  • Compsolid Ein zusammengesetzter Körper (solid) ist ein Set von Körpern, die durch ihre Seiten verbunden sind. Dies erweitert das Konzept von WIRE and SHELL auf Körpern (solids).
  • Solid Ein Teil des Raumes, der durch eine geschlossene dreidimensionale Hülle begrenzt ist.
  • Shell Hülle = Ein Satz von über ihre Kanten verbundenen Flächen. Eine Hülle kann offen oder geschlossen sein.
  • Face Im zweidimensionalen ist es ein Teil einer Ebene; im dreidimensionalen ist es ein Teil einer Oberfläche. Die Form ist durch Konturen begrenzt (getrimmt). Auch im 3D gekrümmte Flächen haben sind Inneren zweidimensional parametriert.
  • Wire Ein Satz von über ihre Endpunkten verknüpften Kanten. Ein "Wire" kann eine offene oder geschlossene Form haben, je nach dem ob nicht verknüpfte Endpunkte vorhanden sind oder nicht.
  • Edge Ein topologisches Element (Kante) das mit einer beschränkten Kurve korrespondiert. Eine Kante ist generell durch Vertexe begrenzt. Eine Kante ist eindimensional.
  • Vertex Ein topologisches Element das mit einem Punkt korrespondiert. Es ist nulldimensional.
  • Shape Ein generischer Term für all die zuvor aufgezählten Elemente.

Anfang

Beispiel: Einfache Topologie erstellen

Wire

Wir werden nun eine Topologie erstellen, indem wir sie aus einer einfacheren Geometrie konstruieren. Als Fallstudie verwenden wir ein Teil, wie im Bild zu sehen, das aus vier Knoten, zwei Kreise und zwei Linien besteht.

Anfang

Geometrie erstellen

Zuerst erstellen wir die verschiedenen geometrischen Teile dieses Drahtes. Dabei stellen wir sicher, dass die Teile, die später verbunden werden die gleichen Knoten teilen.

Also erstellen wir zuerst die Punkte:

import Part
from FreeCAD import Base
V1 = Base.Vector(0, 10, 0)
V2 = Base.Vector(30, 10, 0)
V3 = Base.Vector(30, -10, 0)
V4 = Base.Vector(0, -10, 0)

Anfang

Bogen

Circle


Für jeden Bogen benötigen wir einen Hilfspunkt:

VC1 = Base.Vector(-10, 0, 0)
C1 = Part.Arc(V1, VC1, V4)
VC2 = Base.Vector(40, 0, 0)
C2 = Part.Arc(V2, VC2, V3)

Anfang

Linie

Line


Die Linienabschnitte können aus zwei Punkten erstellt werden:

L1 = Part.LineSegment(V1, V2)
L2 = Part.LineSegment(V3, V4)

Anfang

Alles zusammensetzen

Der letzte Schritt besteht darin, die geometrischen Basiselemente zusammenzusetzen und eine topologische Form zu backen:

S1 = Part.Shape([C1, L1, C2, L2])

Anfang

Ein Prisma herstellen

Jetzt extrudiere den Draht in eine Richtung und erzeugen eine tatsächliche 3D Form:

W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0, 0, 10))

Anfang

Alles anzeigen

Part.show(P)

Anfang

Erstellen von Grundformen

Du kannst ganz einfach topologische Grundobjekte mit den make...() Methoden aus dem Arbeitsbereich Part erstellen:

b = Part.makeBox(100, 100, 100)
Part.show(b)

Einige verfügbare make...() Methoden:

  • makeBox(l, w, h) Erstellt einen Quader, der sich in p befindet und in die Richtung d mit den Abmessungen (l,w,h) zeigt.
  • makeCircle(radius) Erstellt einen Kreis mit einem gegebenen Radius.
  • makeCone(radius1, radius2, height) Erstellt einen Kegel mit den gegebenen Radien und Höhen.
  • makeCylinder(radius, height) Erstellt einen Zylinder mit einem gegebenen Radius und Höhe.
  • makeLine((x1, y1, z1), (x2, y2, z2)) Erstellt eine Linie aus zwei Punkten.
  • makePlane(length, width) Erstellt eine Ebene mit Länge und Breite.
  • makePolygon(list) Erstellt ein Polygon aus einer Liste von Punkten.
  • makeSphere(radius) Erstellt eine Kugel mit einem bestimmten Radius.
  • makeTorus(radius1, radius2) Erstellt einen Torus mit den gegebenen Radien.

Siehe die Part API Seite für eine vollständige Liste der verfügbaren Methoden des Part Arbeitsbereichs.

Anfang

Module Importieren

Zuerst müssen wir den Part Arbeitsbereich importieren, damit wir seinen Inhalt in Python verwenden können. Wir werden auch das Basismodul aus dem FreeCAD Modul importieren:

import Part
from FreeCAD import Base

Anfang

Erstellen eines Vektors

Vektoren sind einer der am häufigsten verwendeten wichtigen Informationsteile beim Bau von Formen. Sie enthalten in der Regel drei Zahlen (aber nicht notwendigerweise immer): die kartesischen Koordinaten x, y und z. Du erstellst einen Vektor wie diesen:

myVector = Base.Vector(3, 2, 0)

Wir haben soeben einen Vektor mit den Koordinaten X = 3, Y = 2, Z = 0 erstellt. im Part Arbeitsbereich werden Vektoren überall verwendet. Part Formen verwenden auch eine andere Art von Punkt Darstellung namens Knoten, die einfach ein Behälter ist für einen Vektor. So greifst du auf den Vektor eines Knoten zu:

myVertex = myShape.Vertexes[0]
print(myVertex.Point)
> Vector (3, 2, 0)

Anfang

Erstellen einer Kante

Eine Kante ist nichts anderes als eine Linie mit zwei Knoten:

edge = Part.makeLine((0, 0, 0), (10, 0, 0))
edge.Vertexes
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]

Hinweis: Du kannst auch eine Kante erzeugen, indem du zwei Vektoren übergibst:

vec1 = Base.Vector(0, 0, 0)
vec2 = Base.Vector(10, 0, 0)
line = Part.LineSegment(vec1, vec2)
edge = line.toShape()

Du kannst die Länge und den Mittelpunkt einer Kante wie diese finden:

edge.Length
> 10.0
edge.CenterOfMass
> Vector (5, 0, 0)

Anfang

Die Form auf den Bildschirm bringen

Bisher haben wir ein Kantenobjekt erstellt, das aber nirgendwo auf dem Bildschirm erscheint. Das liegt daran, dass die FreeCAD 3D Szene nur das anzeigt, was du ihm sagst, dass er anzeigen soll. Um das zu tun, verwenden wir folgende einfache Methode:

Part.show(edge)

Die Anzeigefunktion erzeugt ein Objekt in unserem FreeCAD Dokument und weist unsere "Kanten"form ihm zu. Verwende dies, wenn es an der Zeit ist, deine Erstellung auf dem Bildschirm anzuzeigen.

Anfang

Erstellen eines Drahts

Ein Draht ist eine Mehrkantenlinie und kann aus einer Liste von Kanten oder sogar einer Liste von Drähten erstellt werden:

edge1 = Part.makeLine((0, 0, 0), (10, 0, 0))
edge2 = Part.makeLine((10, 0, 0), (10, 10, 0))
wire1 = Part.Wire([edge1, edge2]) 
edge3 = Part.makeLine((10, 10, 0), (0, 10, 0))
edge4 = Part.makeLine((0, 10, 0), (0, 0, 0))
wire2 = Part.Wire([edge3, edge4])
wire3 = Part.Wire([wire1, wire2])
wire3.Edges
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Part.show(wire3)

Part.show(wire3) zeigt die 4 Kanten, die unseren Draht bilden. Sonstige nützliche Informationen können leicht abgerufen werden:

wire3.Length
> 40.0
wire3.CenterOfMass
> Vector (5, 5, 0)
wire3.isClosed()
> True
wire2.isClosed()
> False

Anfang

Erstellen einer Fläche

Nur Flächen, die aus geschlossenen Drähten erstellt wurden, sind gültig. In diesem Beispiel ist Draht3 ein geschlossener Draht, aber Draht2 ist kein geschlossener Draht (siehe oben).

face = Part.Face(wire3)
face.Area
> 99.99999999999999
face.CenterOfMass
> Vector (5, 5, 0)
face.Length
> 40.0
face.isValid()
> True
sface = Part.Face(wire2)
sface.isValid()
> False

Nur Flächen haben eine Grundfläche, Drähte und Kanten haben keine.

Anfang

Erstellen eines Kreises

So einfach kann ein Kreis erstellt werden:

circle = Part.makeCircle(10)
circle.Curve
> Circle (Radius : 10, Position : (0, 0, 0), Direction : (0, 0, 1))

Wenn Du ihn an einer bestimmten Stelle und mit einer bestimmten Richtung erzeugen möchtest:

ccircle = Part.makeCircle(10, Base.Vector(10, 0, 0), Base.Vector(1, 0, 0))
ccircle.Curve
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))

ccircle wird im Abstand 10 vom x Ursprung erstellt und ist nach außen entlang der x Achse gerichtet. Hinweis: makeCircle() akzeptiert nur Base.Vector() für die Position und normale Parameter, keine Tupel. Du kannst auch einen Teil des Kreises durch Angabe eines Anfangs- und eines Endwinkels erstellen:

from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 180, 360)

Winkel sollten in Grad angegeben werden. Wenn Du Bogenmaß hast, wandelst Du sie einfach mit der Formel um: Template:Incode/de oder mit Hilfe des Python math Moduls:

import math
degrees = math.degrees(radians)

Anfang

Erstellen eines Bogens entlang von Punkten

Leider gibt es keine makeArc() Funktion, aber wir haben die Part.Arc() Funktion um einen Bogen durch drei Punkte zu erzeugen. Es erzeugt ein Bogenobjekt das den Startpunktes mit dem Endpunkt durch den Mittelpunkt verbindet. Die toShape() Funktion des Bogenobjekts muss aufgerufen werden, um ein Kantenobjekt zu erhalten, wie bei der Verwendung von Part.LineSegment anstelle von Part.makeLine.

arc = Part.Arc(Base.Vector(0, 0, 0), Base.Vector(0, 5, 0), Base.Vector(5, 5, 0))
arc
> <Arc object>
arc_edge = arc.toShape()
Part.show(arc_edge)

Arc() akzeptiert nur Base.Vector() für Punkte, aber nicht für Tupel. Du kannst auch Folgendes erhalten einen Bogen unter Verwendung eines Kreisausschnitts:

from math import pi
circle = Part.Circle(Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 10)
arc = Part.Arc(circle,0,pi)

Bögen sind gültige Kanten wie Linien, so dass sie auch in Drähten verwendet werden können.

Anfang

Erstellen eines Polygons

Ein Polygon ist einfach ein Draht mit mehreren geraden Kanten. Die makePolygon() Funktion nimmt eine Liste von Punkten und erstellt einen Draht durch diese Punkte:

lshape_wire = Part.makePolygon([Base.Vector(0, 5, 0), Base.Vector(0, 0, 0), Base.Vector(5, 0, 0)])

Anfang

Erstellen einer Bézier Kurve

Bézier Kurven werden verwendet, um sanfte Kurven mit einer Reihe von Polen (Punkten) und optionalen Gewichten zu modellieren. Die folgende Funktion erstellt eine Part.BezierCurve() aus einer Reihe von FreeCAD.Vector() Punkten. (Hinweis: Wenn du einen einzelnen Pol oder ein Gewicht "erhältst" und "einstellst", beginnen die Indizes bei 1, nicht bei 0.)

def makeBCurveEdge(Points):
   geomCurve = Part.BezierCurve()
   geomCurve.setPoles(Points)
   edge = Part.Edge(geomCurve)
   return(edge)

Anfang

Erstellen einer Ebene

Eine Ebene ist einfach eine flache rechteckige Fläche. Die Methode, mit der eine solche erstellt wird, ist makePlane(length,width,[start_pnt,dir_normal])'. Standardmäßig start_pnt = Vektor(0,0,0,0) und dir_normal = Vektor(0,0,1). Verwendung von dir_normal = Vector(0,0,0,1) erzeugt die Ebene, die in Richtung der positiven z Achse zeigt, während dir_normal = Vector(1,0,0,0) die Ebene erzeugt, die in Richtung der positiven x Achse zeigt:

plane = Part.makePlane(2, 2)
plane
> <Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3, 0, 0), Base.Vector(0, 1, 0))
plane.BoundBox
> BoundBox (3, 0, 0, 5, 0, 2)

BoundBox ist ein Quader, der die Ebene mit einer Diagonale beginnend bei (3,0,0,0) und endet bei (5,0,2) einschliesst. Hier ist die BoundBox Dicke entlang der y Achse Null, zumal unsere Form völlig flach ist.

Hinweis: makePlane() akzeptiert nur Base.Vector() für start_pnt und dir_normal, nicht aber Tupel.

Anfang

Erstellen einer Ellipse

Es gibt mehrere Möglichkeiten, eine Ellipse zu erstellen:

Part.Ellipse()

Erzeugt eine Ellipse mit Hauptradius 2 und Nebenradius 1 mit dem Mittelpunkt bei (0,0,0).

Part.Ellipse(Ellipse)

Erstellt eine Kopie der angegebenen Ellipse.

Part.Ellipse(S1, S2, Center)

Erzeugt eine Ellipse, die auf den Punkt Mitte zentriert ist, an dem die Ebene der Ellipse definiert ist durch Mittelpunkt, S1 und S2, ihre Hauptachse definiert ist durch Mittelpunkt und S1, sein Hauptradius ist der Abstand zwischen Mittelpunkt und S1, und sein kleiner Radius ist der Abstand zwischen S2 und der Hauptachse.

Part.Ellipse(Center, MajorRadius, MinorRadius)

Erstellt eine Ellipse mit Haupt- und Nebenradien Hauptradius und Nebenradius, die sich in der durch den Mittelpunkt definierten Ebene und der Normalen (0,0,1) befinden.

eli = Part.Ellipse(Base.Vector(10, 0, 0), Base.Vector(0, 5, 0), Base.Vector(0, 0, 0))
Part.show(eli.toShape())

Im obigen Code haben wir S1, S2 und Mitte überschritten. Ähnlich wie Arc, Ellipse erzeugt ein Ellipsenobjekt, aber keine Kante, also müssen wir es in eine Kante mit toShape() zur Anzeige konvertieren.

Hinweis: Ellipse() akzeptiert nur Base.Vector() für Punkte, nicht aber für Tupel.

eli = Part.Ellipse(Base.Vector(0, 0, 0), 10, 5)
Part.show(eli.toShape())

Für den obigen Ellipsenkonstruktor haben wir Mitte, HauptRadius und NebenRadius überschritten.

Anfang

Erstellen eines Torus

Verwende makeTorus(radius1, radius2, [pnt, dir, Winkel1, Winkel2, Winkel]). Standardmäßig ist pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = 0, Winkel2 = 360 und Winkel = 360. Betrachte einen Torus als kleinen Kreis, der entlang eines großen Kreises verläuft. Radius1 ist der Radius des großen Kreises, Radius2 ist der Radius des kleinen Kreises, pnt ist der Mittelpunkt des Torus und dir ist die Normalenrichtung. winkel1 und winkel2 sind Winkel in Grad für den kleinen Kreis; der letzte Winkelparameter besteht darin, einen Schnitt von den Torus:

torus = Part.makeTorus(10, 2)

Der obige Code erzeugt einen Torus mit Durchmesser 20 (Radius 10) und Dicke 4 (kleiner Kreisradius 2)

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)

Der obige Code erzeugt eine Scheibe des Torus.

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 360, 180)

Der obige Code erzeugt einen Halbtorus; nur der letzte Parameter wird geändert. d.h. die restlichen Winkel sind Standardwerte. Die Angabe des Winkels 180 bewirkt den Torus von 0 bis 180, d.h. einen halben Torus, erzeugen.

Anfang

Kasten oder Quader erstellen

Verwendung von makeBox(Länge, Breite, Höhe, [pnt, dir]). Standardmäßig werden pnt = Vektor(0, 0, 0) und dir = Vektor(0, 0, 1) verwendet.

box = Part.makeBox(10, 10, 10)
len(box.Vertexes)
> 8

Anfang

Erstelle eine Kugel

Mit makeSphere(radius, [pnt, dir, winkel1, winkel2, winkel3]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = -90, Winkel2 = 90 und Winkel3 = 360. Winkel1 und Winkel2 sind das vertikale Minimum und Maximum der Kugel, Winkel3 ist der Kugeldurchmesser.

sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), -90, 90, 180)

Anfang

Erstellen eines Zylinders

Verwende makeCylinder(Radius, Höhe, [pnt, dir, Winkel]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.

cylinder = Part.makeCylinder(5, 20)
partCylinder = Part.makeCylinder(5, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

Anfang

Erstellen eines Kegels

Verwendung makeCone(radius1, radius2, höhe, [pnt, dir, winkel]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.

cone = Part.makeCone(10, 0, 20)
semicone = Part.makeCone(10, 0, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

Anfang

Formen ändern

Es gibt verschiedene Möglichkeiten, Formen zu ändern. Einige sind einfache Transformationsoperationen wie sich bewegende oder rotierende Formen, andere sind komplexer, wie die Vereinigung und Subtrahieren einer Form von einer anderen.

Anfang

Umwandlungsvorgänge

Übersetzen einer Form

Übersetzen ist die Handlung, eine Form von einem Ort zum anderen zu bewegen. Jede Form (Kante, Fläche, Würfel, usw...) kann auf die gleiche Weise übersetzt werden:

myShape = Part.makeBox(2, 2, 2)
myShape.translate(Base.Vector(2, 0, 0))

Dadurch wird unsere Form "myShape" um 2 Einheiten in die X Richtung verschoben.

Anfang

Drehen einer Form

Um eine Form zu drehen, musst du das Rotationszentrum, die Achse, angeben, und den Rotationswinkel:

myShape.rotate(Base.Vector(0, 0, 0),Base.Vector(0, 0, 1), 180)

Der obige Code dreht die Form um 180 Grad um die Z Achse.

Anfang

Matrix Umformungen

Eine Matrix ist eine sehr bequeme Möglichkeit, Transformationen in der 3D Welt. In einer einzigen Matrix kannst du Translation, Rotation und Skalierung einstellen Werte, die auf ein Objekt angewendet werden sollen. Zum Beispiel:

myMat = Base.Matrix()
myMat.move(Base.Vector(2, 0, 0))
myMat.rotateZ(math.pi/2)

Hinweis: FreeCAD Matrizen arbeiten im Bogenmaß. Außerdem werden fast alle Matrix Operationen die einen Vektor nehmen, können auch drei Zahlen nehmen, so dass diese beiden Linien dasselbe tun:

myMat.move(2, 0, 0)
myMat.move(Base.Vector(2, 0, 0))

Wenn unsere Matrix einmal festgelegt ist, können wir sie auf unsere Form anwenden. FreeCAD bietet zwei Methoden, um das zu tun: transformShape() und transformGeometry(). Der Unterschied ist, dass Sie bei der ersten sicher sind, dass keine Verformungen auftreten werden (siehe Skalierung einer Form unten). Wir können unsere Transformation wie folgt anwenden:

myShape.transformShape(myMat)

oder

myShape.transformGeometry(myMat)

Anfang

Skalieren einer Form

Das Skalieren einer Form ist eine gefährlichere Operation, denn im Gegensatz zur Übersetzung oder Rotation, ungleichmäßige Skalierung (mit unterschiedlichen Werten für X, Y und Z) kann die Struktur der Form verändern. Beispielsweise kann die Skalierung eines Kreises mit ein höherer Wert horizontal als vertikal wandelt ihn in einen Ellipse, die sich mathematisch sehr unterschiedlich verhält. Für die Skalierung haben wir nicht die transformShape() verwenden können, müssen wir transformGeometry() verwenden:

myMat = Base.Matrix()
myMat.scale(2, 1, 1)
myShape=myShape.transformGeometry(myMat)

Anfang

Boolesche Operationen

Subtraktion

Das Subtrahieren einer Form von einer anderen Form wird in FreeCAD "Schnitt" genannt und wird so gemacht:

cylinder = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
sphere = Part.makeSphere(5, Base.Vector(5, 0, 0))
diff = cylinder.cut(sphere)

Anfang

Überschneidung

Auf die gleiche Weise wird die Überschneidung zwischen zwei Formen als "gemeinsam" bezeichnet und auf diese Weise gemacht:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
common = cylinder1.common(cylinder2)

Anfang

Vereinigen

Vereinigen wird "Verschmelzen" genannt und funktioniert auf dieselbe Weise:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
fuse = cylinder1.fuse(cylinder2)

Anfang

Abschnitt

Ein "Abschnitt" ist der Kreuzungspunkt zwischen einer festen Form und einer ebenen Form. Er gibt eine Kreuzungskurve, eine Verbundkurve, die aus Kanten besteht zurück.

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
section = cylinder1.section(cylinder2)
section.Wires
> []
section.Edges
> [<Edge object at 0D87CFE8>, <Edge object at 019564F8>, <Edge object at 0D998458>, 
 <Edge  object at 0D86DE18>, <Edge object at 0D9B8E80>, <Edge object at 012A3640>, 
 <Edge object at 0D8F4BB0>]

Anfang

Extrusion

Extrusion ist der Vorgang des "Drückens" einer flachen Form in eine bestimmte Richtung, was zu einem festen Körper führt. Stell dir vor, dass ein Kreis durch "Herausschieben" zu einer Röhre wird:

circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0, 0, 2))

Wenn dein Kreis hohl ist, erhälst du ein hohles Rohr. Wenn dein Kreis tatsächlich eine Scheibe mit einer gefüllten Fläche ist, erhälst du einen massiven Zylinder:

wire = Part.Wire(circle)
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0, 0, 2))

Anfang

Formen untersuchen

Du kannst die topologische Datenstruktur leicht erkunden:

import Part
b = Part.makeBox(100, 100, 100)
b.Wires
w = b.Wires[0]
w
w.Wires
w.Vertexes
Part.show(w)
w.Edges
e = w.Edges[0]
e.Vertexes
v = e.Vertexes[0]
v.Point

Durch tippen der obigen Zeilen in den Python Interpreter, erhälst du eine gutes Verständnis der Struktur von Teilobjekten. Hier hat unser makeBox() Befehl eine feste Form geschaffen. Dieser Volumenkörper enthält, wie alle Teil Volumenkörper, Flächen. Flächen enthalten immer Drähte, d.h. Listen von Kanten, die die Fläche begrenzen. Jede Fläche hat mindestens einen geschlossenen Draht (sie kann mehr haben, wenn die Fläche ein Loch hat). In dem Draht können wir jede Kante einzeln betrachten, und innerhalb jeder Kante können wir siehe die Eckpunkte. Gerade Kanten haben offensichtlich nur zwei Knoten.

Anfang

Kantenanalyse

Im Falle einer Kante, die eine willkürliche Kurve ist, ist es am wahrscheinlichsten, dass du eine Diskretisierung durchführen möchtest. In FreeCAD werden die Kanten durch ihre Länge parametrisiert. Das bedeutet, dass du eine Kante/Kurve anhand ihrer Länge entlang laufen kannst:

import Part
box = Part.makeBox(100, 100, 100)
anEdge = box.Edges[0]
print(anEdge.Length)

Jetzt kannst du auf viele Eigenschaften der Kante zugreifen, indem du die Länge als Position verwendest. Das heißt, wenn die Kante 100 mm lang ist, ist die Startposition 0 und die Endposition 100.

anEdge.tangentAt(0.0)          # tangent direction at the beginning
anEdge.valueAt(0.0)            # Point at the beginning
anEdge.valueAt(100.0)          # Point at the end of the edge
anEdge.derivative1At(50.0)     # first derivative of the curve in the middle
anEdge.derivative2At(50.0)     # second derivative of the curve in the middle
anEdge.derivative3At(50.0)     # third derivative of the curve in the middle
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0)       # the curvature
anEdge.normalAt(50)            # normal vector at that position (if defined)

Anfang

Verwendung einer Auswahl

Hier sehen wir nun, wie wir eine Auswahl verwenden können, die der Benutzer im Betrachter getroffen hat. Zuerst erstellen wir einen Kasten und zeigen ihn im Betrachter an.

import Part
Part.show(Part.makeBox(100, 100, 100))
Gui.SendMsgToActiveView("ViewFit")

Wähle nun einige Flächen oder Kanten aus. Mit diesem Skript kannst du über alle ausgewählten Objekte und deren Unterelemente iterieren:

for o in Gui.Selection.getSelectionEx():
    print(o.ObjectName)
    for s in o.SubElementNames:
        print("name: ", s)
        for s in o.SubObjects:
            print("object: ", s)

Wähle einige Kanten aus und dieses Skript berechnet die Länge:

length = 0.0
for o in Gui.Selection.getSelectionEx():
    for s in o.SubObjects:
        length += s.Length

print("Length of the selected edges: ", length)

Anfang

Beispiel: Die OCC Flasche

Ein typisches Beispiel, das auf der OpenCasCade Technology Website zu finden ist, ist der Bau einer Flasche. Dies ist auch eine gute Übung für FreeCAD. Wenn du unserem Beispiel unten und der OCC-Seite gleichzeitig folgst, wirst du sehen, wie gut OCC Strukturen in FreeCAD implementiert sind. Das Skript ist in der FreeCAD Installation enthalten (innerhalb des Ordners Mod/Part) und kann vom Python Interpreter durch Eintippen aufgerufen werden:

import Part
import MakeBottle
bottle = MakeBottle.makeBottle()
Part.show(bottle)

Anfang

Das Skript=

Für die Zwecke dieses Tutoriums werden wir eine reduzierte Version des Skripts in Betracht ziehen. In dieser Version wird die Flasche nicht ausgehöhlt, und der Flaschenhals wird nicht mit einem Gewinde versehen.

import Part, math
from FreeCAD import Base

def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
    aPnt5=Base.Vector(myWidth / 2., 0, 0)

    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
    aSegment2=Part.LineSegment(aPnt4, aPnt5)

    aEdge1=aSegment1.toShape()
    aEdge2=aArcOfCircle.toShape()
    aEdge3=aSegment2.toShape()
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])

    aTrsf=Base.Matrix()
    aTrsf.rotateZ(math.pi) # rotate around the z-axis

    aMirroredWire=aWire.copy()
    aMirroredWire.transformShape(aTrsf)
    myWireProfile=Part.Wire([aWire, aMirroredWire])

    myFaceProfile=Part.Face(myWireProfile)
    aPrismVec=Base.Vector(0, 0, myHeight)
    myBody=myFaceProfile.extrude(aPrismVec)

    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)

    neckLocation=Base.Vector(0, 0, myHeight)
    neckNormal=Base.Vector(0, 0, 1)

    myNeckRadius = myThickness / 4.
    myNeckHeight = myHeight / 10.
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)
    myBody = myBody.fuse(myNeck)

    return myBody

el = makeBottleTut()
Part.show(el)

Anfang

Detaillierte Erklärung

import Part, math
from FreeCAD import Base

Wir benötigen natürlich das Modul Part, aber auch das Modul FreeCAD.Base, das grundlegende FreeCAD Strukturen wie Vektoren und Matrizen enthält.

def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
    aPnt5=Base.Vector(myWidth / 2., 0, 0)

Hier definieren wir unsere makeBottleTut Funktion. Diese Funktion kann aufgerufen werden ohne Argumente, wie wir es oben getan haben, in diesem Fall Standardwerte für Breite und Höhe, und Dicke verwendet werden. Dann definieren wir ein paar Punkte, die verwendet werden für den Aufbau unseres Basisprofils.

...
    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
    aSegment2=Part.LineSegment(aPnt4, aPnt5)

Hier definieren wir die Geometrie: einen Bogen, der aus drei Punkten besteht, und zwei Liniensegmente, die aus zwei Punkten bestehen.

...
    aEdge1=aSegment1.toShape()
    aEdge2=aArcOfCircle.toShape()
    aEdge3=aSegment2.toShape()
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])

Erinnerst du dich an den Unterschied zwischen Geometrie und Formen? Hier bauen wir Formen aus unserer Konstruktionsgeometrie. Drei Kanten (Kanten können gerade sein oder gebogen), dann einen Draht hergestellt aus diesen drei Kanten.

...
    aTrsf=Base.Matrix()
    aTrsf.rotateZ(math.pi) # rotate around the z-axis

    aMirroredWire=aWire.copy()
    aMirroredWire.transformShape(aTrsf)
    myWireProfile=Part.Wire([aWire, aMirroredWire])

Bislang haben wir nur ein halbes Profil erstellt. Anstatt das ganze Profil zu bauen Auf die gleiche Weise können wir einfach spiegeln, was wir getan haben, und beide Hälften zusammenkleben. Zuerst erstellen wir eine Matrix. Eine Matrix ist ein sehr gebräuchlicher Weg, um Transformationen auf Objekte in der 3D Welt anzuwenden, da sie in einer Struktur alle grundlegenden Transformationen, denen 3D Objekte unterzogen werden können (Verschieben, Drehen und Skalieren) enthalten. Nachdem wir die Matrix erstellt haben, spiegeln wir sie, dann erstellen wir eine Kopie unseres Drahtes und wenden die Transformationsmatrix darauf an. Wir haben jetzt zwei Drähte, und können wir einen dritten Draht aus ihnen machen, da Drähte eigentlich Listen von Kanten sind.

...
    myFaceProfile=Part.Face(myWireProfile)
    aPrismVec=Base.Vector(0, 0, myHeight)
    myBody=myFaceProfile.extrude(aPrismVec)

    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)

Nun, da wir einen geschlossenen Draht haben, kann er in eine Fläche verwandelt werden. Sobald wir eine Fläche haben, können wir es extrudieren. Auf diese Weise machen wir einen Festkörper. Dann wenden wir eine schöne kleine Verrundung auf unser Objekt an, weil wir uns um gutes Design kümmern, nicht wahr?

...
    neckLocation=Base.Vector(0, 0, myHeight)
    neckNormal=Base.Vector(0, 0, 1)

    myNeckRadius = myThickness / 4.
    myNeckHeight = myHeight / 10.
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)

An diesem Punkt ist der Körper unserer Flasche hergestellt, aber wir müssen noch einen Hals schaffen. Wir stellen einen neuen Körper mit einem Zylinder her.

...
    myBody = myBody.fuse(myNeck)

Der Verschmelzungsoperation ist sehr leistungsstark. Sie kümmert sich um das Kleben, was geklebt werden muss, und entfernt Teile, die entfernt werden müssen.

...
    return myBody

Dann geben wir als Ergebnis unserer Funktion unseren Part Volumenkörper zurück.

el = makeBottleTut()
Part.show(el)

Schließlich rufen wir die Funktion auf, um das Teil tatsächlich zu erstellen und es dann sichtbar zu machen.

Anfang

Beispiel: Durchbohrter Quader

Hier ist ein vollständiges Beispiel für den Bau eines durchbohrten Quaders.

Der Aufbau erfolgt von einer Seite nach der anderen. Wenn der Würfel fertig ist, wird er durch das Durchschneiden eines Zylinders ausgehöhlt.

import Part, math
from FreeCAD import Base

size = 10
poly = Part.makePolygon([(0, 0, 0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])

face1 = Part.Face(poly)
face2 = Part.Face(poly)
face3 = Part.Face(poly)
face4 = Part.Face(poly)
face5 = Part.Face(poly)
face6 = Part.Face(poly)
     
myMat = Base.Matrix()

myMat.rotateZ(math.pi / 2)
face2.transformShape(myMat)
face2.translate(Base.Vector(size, 0, 0))

myMat.rotateZ(math.pi / 2)
face3.transformShape(myMat)
face3.translate(Base.Vector(size, size, 0))

myMat.rotateZ(math.pi / 2)
face4.transformShape(myMat)
face4.translate(Base.Vector(0, size, 0))

myMat = Base.Matrix()

myMat.rotateX(-math.pi / 2)
face5.transformShape(myMat)

face6.transformShape(myMat)               
face6.translate(Base.Vector(0, 0, size))

myShell = Part.makeShell([face1, face2, face3, face4, face5, face6])   
mySolid = Part.makeSolid(myShell)

myCyl = Part.makeCylinder(2, 20)
myCyl.translate(Base.Vector(size / 2, size / 2, 0))

cut_part = mySolid.cut(myCyl)

Part.show(cut_part)

Anfang

Laden und Speichern

Es gibt mehrere Möglichkeiten, deine Arbeit zu speichern. Du kannst natürlich dein FreeCAD Dokument speichern, aber Du kannst auch Part Objekte direkt in gängigen CAD Formaten wie BREP, IGS, STEP und STL speichern.

Das Speichern einer Form in einer Datei ist einfach. Es stehen die Methoden exportBrep(), exportIges(), exportStep() und exportStl() für alle Formobjekte zur Verfügung. Also, ausführen:

import Part
s = Part.makeBox(10, 10, 10)
s.exportStep("test.stp")

wird unseren Quader in eine STEP Datei gespeichert. Um eine BREP , IGES oder STEP Datei zu laden:

import Part
s = Part.Shape()
s.read("test.stp")

Um eine STEP Datei in eine IGS Datei umzuwandeln:

import Part
 s = Part.Shape()
 s.read("file.stp")       # incoming file igs, stp, stl, brep
 s.exportIges("file.igs") # outbound file igs

Anfang